#include "boolext.h"

//----------
//- debug 
//----------
typedef struct tagHGDEBUG_STR_VAL {
	HGDEBUG_ID	Val;
	p_str		Str;
} HGDEBUG_STR_VAL, FAR *LPHGDEBUG_STR_VAL;

#define _HGDEBUG_TITLE		" (Debug State)"

HGDEBUG_STR_VAL HGDebugStrVal[] = {
	HGDBID_BFSIZEISZERO,	"ٲ ڿ  ̴ '0'(zero)Դϴ.",
	HGDBID_BFSIZEOVERFLOW,	"ٲ ڿ ̰  ũ⸦ ʰϿϴ.",
	HGDBID_NON,				"ɰ  ֽϴ. ݵ ȮϽʽÿ.",
	HGDBID_FAILEDMEM,		"޸ ϱ ",
	HGDBID_FATAL_MEMERR,	"ġ ޸  - ǻ ȯ Ȯ",
    HGDBID_INVALID_CHAR,    "ҿ ڵ带 Ͽϴ.",
	HGDBID_ENDMARK,			"***"
};

#ifdef _HGDEBUG_

void  HGALERT(p_str FILE_name, UINT LINE_num, BOOL Flag)
{
#ifdef _HGDEBUG_
	p_str		lpMsg;
	
	if(Flag != FALSE) {	// FALSE  óѴ.
		return;
	}
	if(FILE_name == NULL) {
		return;
	}
	if(LINE_num < 1) {
		return;
	}
	
	lpMsg = (p_str)HGMemAlloc((HGKBSIZE * 10));
	if(lpMsg == NULL) {
		HGMsgBox_Err(HGGetDbgMsgString(HGDBID_FATAL_MEMERR));
		return;
	}

	HGSprintf((p_str)lpMsg, "[%u] - %s ", LINE_num, FILE_name);
	HGMsgBox_See(lpMsg);
	HGMemFree(lpMsg);

#endif	// _HGDEBUG_
}

void  HGDEBUGALERT(p_str FILE_name, UINT LINE_num, HGDEBUG_ID hgDbgID, p_str hgDbgStr)
{
	p_str		lpMsg;
	p_str		lpDbgMsg;
	
	HGASSERT(FILE_name != NULL);

	if(FILE_name == NULL) {
		return;
	}
	if(LINE_num < 1) {
		return;
	}
	
	lpMsg = (p_str)HGMemAlloc((HGKBSIZE * 10));
	if(lpMsg == NULL) {
		HGMsgBox(HGGetDbgMsgString(HGDBID_FATAL_MEMERR), _HGDEBUG_TITLE, MB_OK);
		return;
	}

	// "hgDbgStr" 켱 Ѵ.   ϰ,  "hgDbgID" Ѵ.
	if(hgDbgStr) {
		HGSprintf((p_str)lpMsg, "[%u] - %s  \n%s", LINE_num, FILE_name, hgDbgStr);
	}
	else {
		lpDbgMsg = NULL;
		
		switch(hgDbgID) {
		case HGDBID_FATAL_MEMERR:
		case HGDBID_FAILEDMEM:
		case HGDBID_BFSIZEISZERO:
		case HGDBID_BFSIZEOVERFLOW:
			lpDbgMsg = HGGetDbgMsgString(hgDbgID);
			break;
		case HGDBID_ENDMARK:
		case HGDBID_NON:
		default:
			lpDbgMsg = HGGetDbgMsgString(HGDBID_DEFAULT);
			break;
		}
		if(lpDbgMsg == NULL) {
			HGSprintf((p_str)lpMsg, "[%u] - %s  \n", LINE_num, FILE_name);
		}
		else {
			if(lpDbgMsg == nnull) {
				HGSprintf((p_str)lpMsg, "[%u] - %s  \n", LINE_num, FILE_name);
			}
			else {
				HGSprintf((p_str)lpMsg, "[%u] - %s  \n%s", LINE_num, FILE_name, lpDbgMsg);
			}
		}
	}
	
	HGMsgBox(lpMsg, _HGDEBUG_TITLE, MB_OK);
	HGMemFree(lpMsg);
}

p_str  HGGetDbgMsgString(HGDEBUG_ID hgDbgID)
{
	HGDEBUG_ID		IDCnt;
	
	IDCnt = 0;
	while(HGDebugStrVal[IDCnt].Val != HGDBID_ENDMARK) {
		if(HGDebugStrVal[IDCnt].Val == hgDbgID) {
			return HGDebugStrVal[IDCnt].Str;
		}
		IDCnt++;
	}
	
	return NULL;
}

#endif	// _HGDEBUG_

long HGLSeek(HFILE hFile, long Offset, int SeekMode)
{
	long	RetVal;
	
	HGASSERT(hFile != HFILE_ERROR);

#ifdef _HGWINVER_
	RetVal = _llseek (hFile, Offset, SeekMode) ;
#else	//_HGWINVER_
	RetVal = lseek (hFile, Offset, SeekMode) ;
#endif	//_HGWINVER_

	return RetVal;
}

int  HGFileOpen(LPCSTR filename, int oflag)
{
	int		RetVal;
	
	HGASSERT(filename != NULL);

#ifdef _HGWINVER_
	RetVal = _lopen(filename, oflag);
#else	//_HGWINVER_
	RetVal = open(filename, oflag);
	if(RetVal == HFILE_ERROR) {
		return RetVal;
	}
	setmode(RetVal, _O_BINARY);
#endif	//_HGWINVER_

	return RetVal;
}

int  HGFileCreate(LPCSTR filename, int oflag)
{
	int		RetVal;
	
	HGASSERT(filename != NULL);

#ifdef _HGWINVER_
	RetVal = _lcreat(filename, oflag);
#else	//_HGWINVER_
	RetVal = creat(filename, oflag);
	if(RetVal == HFILE_ERROR) {
		return RetVal;
	}
	setmode(RetVal, _O_BINARY);

    // unix 迭 mode [|׷|ٸ] Ͽ 
    //   Ƿ  а  ¸ Ѵ.
    // creat()δ ϰ  带   .
    // ׷  chmod() ؾ Ѵ.
    HGFileClose(RetVal);

    chmod(filename, FILE_CREATE_MODE);

    RetVal = HGFileOpen(filename, READ_WRITE);
#endif	//_HGWINVER_

	return RetVal;
}

int  HGFileClose(int handle)
{
	int		RetVal;
	
#ifdef _HGWINVER_
	RetVal = _lclose(handle);
#else	//_HGWINVER_
	RetVal = close(handle);
#endif	//_HGWINVER_

	return RetVal;
}

int   HGFileRead(int handle, LPVOID buffer, UINT count)
{
	int		RetVal;
	
	HGASSERT((handle != HFILE_ERROR) && (buffer != NULL));

#ifdef _HGWINVER_
	RetVal = _lread(handle, buffer, count);
#else	//_HGWINVER_
	RetVal = read(handle, buffer, count);
#endif	//_HGWINVER_

	return RetVal;
}

int HGFileWrite(int handle, LPVOID buffer, UINT count)
{
	int		RetVal;
	
	HGASSERT((handle != HFILE_ERROR) && (buffer != NULL));

#ifdef _HGWINVER_
	RetVal = _lwrite(handle, (LPCSTR)buffer, count);
#else	//_HGWINVER_
	RetVal = write(handle, buffer, count);
#endif	//_HGWINVER_

	return RetVal;
}

UINT HGStrLen(LPCSTR String)
{
	size_t	RetVal;
	
	HGASSERT(String != NULL);
	if(String == NULL) {
		return 0;
	}

	RetVal = strlen(String);

	return (UINT)RetVal;
}

LPVOID HGMemAlloc(UINT AllocSize)
{
    LPVOID   p_str;

//----------------------------------------------------------------------------------
//----------------------------------------------------------------------------------
// ޸𸮸 ȮϷ ܵ debug ڵ
//----------------------------------------------------------------------------------
//-#ifdef _HGDEBUG_
//-    int     Dummy;
//-
//-    switch(AllocSize) {
//-    case 12:
//-        Dummy = 0;
//-        break;
//-    case 72:
//-        Dummy = 1;
//-        break;
//-    case 7:
//-        Dummy = 2;
//-        //-HGMsgBox_See("׿ ˻ ڵ - ޸𸮸 Ҵ Ȯմϴ.");
//-        break;
//-    }
//-#endif  // _HGDEBUG_
//----------------------------------------------------------------------------------
//----------------------------------------------------------------------------------

    //
    p_str = NULL;
	
#ifdef _HGWINVER_
	p_str = (LPVOID)malloc((size_t)(AllocSize));
	if(p_str) {
		memset(p_str, 0, AllocSize);
    }
#else	//_HGWINVER_
	p_str = (LPVOID)malloc((UINT)((size_t)(AllocSize)));
	if(p_str) {
		memset(p_str, 0, AllocSize);
    }
#endif	//_HGWINVER_
	
	if(p_str == NULL) {
		// Debug° ƴ϶  .
		// ޸𸮸  ϴ  ̻ ۾    ̴.
		HGMsgBox("ġ ޸ \n޸𸮰 մϴ.", "ǻ ȯ Ȯ", MB_OK);
	}

	return p_str;
}

void HGMemFree(LPVOID lpMem)
{
	HGASSERT(lpMem != NULL);

#ifdef _HGWINVER_
    if(lpMem) {
		free(lpMem);
        lpMem = nnull;
    }
#else	//_HGWINVER_
    if(lpMem) {
		free(lpMem);
        lpMem = nnull;
    }
#endif	//_HGWINVER_
}

UINT HGMemSize(LPVOID lpMem)
{
	HGASSERT(lpMem != NULL);

#ifdef _HGWINVER_
	return ((UINT)_msize(lpMem));
#else	//_HGWINVER_
	//  ʰ ִ. - ߿   Ķ.
    return 0;
#endif	//_HGWINVER_
	
}

void HGMemSet(p_str Str, int Type, UINT Size)
{
	HGASSERT(Str != NULL);

#ifdef _HGWINVER_
	memset(Str, Type, Size);
#else	//_HGWINVER_
	memset(Str, Type, Size);
#endif	//_HGWINVER_
}

int HGMsgGuiBox(LPCSTR lpszText, LPCSTR lpszTitle, UINT fuStyle)
{
#ifdef _HGWINVER_
	HWND	ShowHnd;
	p_str	lpText, lpTitle;
	UINT	Style;
	int		RetSt;

	// Beep
	HGMsgBeep;

    // get-title
	if(lpszText == NULL) {
		lpText = "";
	}
	else {
		lpText = (p_str)lpszText;
	}
	if(lpszTitle == NULL) {
		lpTitle = NULL;
	}
	else {
		lpTitle = (p_str)lpszTitle;
	}
	
    // get-style
    //-MB_DEFAULT_DESKTOP_ONLY
	Style = MB_OK | MB_APPLMODAL;
    Style |= fuStyle;

	// get-active-hnd
	#ifdef _HGMFCVER_
        ShowHnd = NULL; // dummy-code for compile
        //-RetSt = AfxMessageBox(lpText, Style);
        RetSt = MessageBox(ShowHnd, lpText, lpTitle, Style);
    #else // _HGMFCVER_
        ShowHnd = GetActiveWindow();
	    if(ShowHnd == NULL) {
            RetSt = HGMsgConBox(lpText, lpTitle, Style);
	    }
	    else {
		    #ifdef _HGWINCON_
                RetSt = HGMsgConBox(lpText, lpTitle, Style);
            #else   // _HGWINCON_
		        RetSt = MessageBox(ShowHnd, lpText, lpTitle, Style);
            #endif  // _HGWINCON_
	    }
        if(ShowHnd) {
	        SetFocus(ShowHnd);
        }
	#endif // _HGMFCVER_
	
	return RetSt;
#else	//_HGWINVER_
	return MB_OK;
#endif	//_HGWINVER_
}

int HGMsgConBox(LPCSTR lpszText, LPCSTR lpszTitle, UINT fuStyle)
{
	p_str	lpText, lpTitle;

	// beep
	HGMsgBeep;

	if(lpszText == NULL) {
		lpText = HGMSGCAP_ERR;
	}
	else {
		lpText = (p_str)lpszText;
	}
	if(lpszTitle == NULL) {
		lpTitle = NULL;
	}
	else {
		lpTitle = (p_str)lpszTitle;
	}
	
	if(lpTitle) {
		printf("\n%s::%s\n", lpTitle, lpText);
	}
	else {
		printf("\n%s\n", lpText);
	}

	return MB_OK;
}

int HGStrCmp(LPCSTR lpOrgStr, LPCSTR lpDstStr)
{
    // return value  ==  0 is same
    //                >  0 is great
    //                <  0 is less
    int				Code1, Code2;
    int				DifVal;

	HGASSERT((lpOrgStr != NULL) && (lpDstStr != NULL));

    if(lpOrgStr == NULL) {
    	if(lpDstStr == NULL) {
    		return __HG_CP_EQ__;
    	}
    	else {
    		return __HG_CP_LESS__;
    	}
    }
    if(lpDstStr == NULL) {
    	if(lpOrgStr == NULL) {
    		return __HG_CP_EQ__;
    	}
    	else {
    		return __HG_CP_MORE__;
    	}
    }

    //
    Code1 = 0;
    Code2 = 0;

    while(TRUE) {
    	Code1 = (BYTE)*lpOrgStr;
    	Code2 = (BYTE)*lpDstStr;
    	
    	if(Code1 != Code2) {
    		break;
    	}
    	
        if (Code1 == '\0') {
            return __HG_CP_EQ__;
        }
        lpOrgStr++;
        lpDstStr++;
    }

    DifVal = Code1 - Code2;
    return DifVal;
}

p_str HGStrCpy(p_str String1, LPCSTR String2)
{
	p_str	RetVal;

	HGASSERT((String1 != NULL) && (String2 != NULL));

    if((String1 == NULL) || (String2 == NULL)) {
		return NULL;
	}

	RetVal = strcpy(String1, String2);

    return RetVal;
}

p_str HGStrDup(p_str String)
{
    hglen       Len;
    p_str       lpRet;

	HGASSERT(String != NULL);

	//--------------------------------------------------
	//--------------------------------------------------
    // ޸ ˻縦 ؼ strdup()  ʴ´.
    //   Լ win95, winnt ۵Ѵ.
	//--------------------------------------------------
    //* return (strdup(String));
	//--------------------------------------------------
	//--------------------------------------------------

    Len = HGStrLen(String);
    if(Len <= hglen_inv) {
        hgdbgbrk;
        return nnull;
    }

    lpRet = (p_str)HGAlloc(Len + 1);
    HGStrCpy(lpRet, String);

    return lpRet;
}

int HGStrNCmp(LPCSTR lpOrgStr, LPCSTR lpDstStr, int Num)
{
    // return value  ==  0 is same
    //                >  0 is great
    //                <  0 is less
    int				Code1, Code2;
    int				DifVal, Count;

	HGASSERT((lpOrgStr != NULL) && (lpDstStr != NULL));

    if(lpOrgStr == NULL) {
    	if(lpDstStr == NULL) {
    		return __HG_CP_EQ__;
    	}
    	else {
    		return __HG_CP_LESS__;
    	}
    }
    if(lpDstStr == NULL) {
    	if(lpOrgStr == NULL) {
    		return __HG_CP_EQ__;
    	}
    	else {
    		return __HG_CP_MORE__;
    	}
    }
    if(Num <= 0) {
    	return __HG_CP_EQ__;
    }

    //
    Count = 0;
    Code1 = 0;
    Code2 = 0;
    while(TRUE) {
    	Code1 = (BYTE)*lpOrgStr;
    	Code2 = (BYTE)*lpDstStr;
    	
    	if(Code1 != Code2) {
    		break;
    	}
    	
        if(Code1 == '\0') {
            return __HG_CP_EQ__;
        }
        lpOrgStr++;
        lpDstStr++;
    	Count++;
    	
    	if(Count == Num) {
    		return __HG_CP_EQ__;
    	}
    }

    DifVal = Code1 - Code2;
    return DifVal;
}

p_str HGStrNCpy(p_str Dst, p_str Src, int Num)
{
	// strncpy()  Լ ٺ ̰ ִ.
	// Լ NULL ߰ ʱ  
    //   strcpyn()ʹ ̰ ־  .
	int			Cnt, Len;
	
	HGASSERT((Dst != NULL) && (Src != NULL));

	if((Dst == NULL) || (Src == NULL)) {
		return NULL;
	}

	Len = (int)strlen(Src);
	if(Len < (Num - 1)) {
		HGStrCpy(Dst, Src);
		Dst[Len] = 0x00;
		return Dst;
	}

	for(Cnt = 0; Cnt < (Num - 1); Cnt++) {
		Dst[Cnt] = Src[Cnt];
	}
	Dst[Cnt] = 0x00;

	return Dst;
}

bbool HGGetTime(LPHGTIME lpHGTime)
{
	struct tm	*newtime;
	time_t		long_time;
    int         YearGab;

	HGASSERT(lpHGTime != nnull);

	if(lpHGTime == nnull) {
		return ffalse;
	}

	time(&long_time);                /* Get time as long integer. */
	newtime = localtime(&long_time ); /* Convert to local time. */
	if(newtime == nnull) {
		hgdbgbrk;
		return ffalse;
	}

	//-***********************************************************************************
	//  ȯ
	//-***********************************************************************************
	//- win95
	//-***********************************************************************************
	//- tm_sec Seconds after minute (0 ?59)
	//- tm_min Minutes after hour (0 ?59)
	//- tm_hour Hours after midnight (0 ?23)
	//- tm_mday Day of month (1 ?31)
	//- tm_mon Month (0 ?11; January = 0)
	//- tm_year Year (current year minus 1900)
	//- tm_wday Day of week (0 ?6; Sunday = 0)
	//- tm_yday Day of year (0 ?365; January 1 = 0)
	//- tm_isdst Positive value if daylight saving time is in effect; 
	//- 	0 if daylight saving time is not in effect; negative value 
	//- 		if status of daylight saving time is unknown. 
	//- 			The C run-time library assumes the United States's rules 
	//- 			for implementing the calculation of Daylight Saving Time (DST). 
	//-***********************************************************************************
	lpHGTime->hiyear = 19;
    lpHGTime->loyear = (char)(newtime->tm_year);
    if(lpHGTime->loyear >= 100) {
        YearGab = (char)(lpHGTime->loyear / 100);
	    lpHGTime->hiyear = (char)(lpHGTime->hiyear + YearGab);
        lpHGTime->loyear = (char)(lpHGTime->loyear - (YearGab * 100));
    }
	lpHGTime->mon = (char)(newtime->tm_mon + 1);// tm_mon + 1
	lpHGTime->day = (char)newtime->tm_mday;
	lpHGTime->hour = (char)newtime->tm_hour;
	lpHGTime->min = (char)newtime->tm_min;
	lpHGTime->sec = (char)newtime->tm_sec;
	lpHGTime->wday = (char)(newtime->tm_wday + 1); // tm_wday + 1
	lpHGTime->hiyday = (char)(newtime->tm_yday / 100);	// (0 - 3; 000, 100, 200, 300) (Day of year)
	lpHGTime->loyday = (char)(newtime->tm_yday % 100);	// (1 - 99; ) (Day of year)

	return ttrue;
}
