#include "codeinfo.h"

/*
struct strucodepair {
	hgstr16 ba_num; //  code
	p_str   p_name;
};
*/

bbool init_codepair(p_codepair p_code)
{
	if(p_code == nnull) {
        hgdbgbrk;
		return ffalse;
	}

	hginitstring((LPSTR)p_code->ba_num, sizeof(p_code->ba_num), 0);
	p_code->p_name = nnull;

	return ttrue;
}

bbool reset_codepair(p_codepair p_code)
{
	if(p_code == nnull) {
        hgdbgbrk;
		return ffalse;
	}

	hginitstring((LPSTR)p_code->ba_num, sizeof(p_code->ba_num), 0);
    if(p_code->p_name != nnull) {
        hgfree(p_code->p_name);
        p_code->p_name = nnull;
    }

	return ttrue;
}

bbool copy_codepair(p_codepair p_code_src, p_codepair p_code_dst)
{
	if((p_code_src == nnull) || (p_code_dst == nnull)) {
        hgdbgbrk;
		return ffalse;
	}

    reset_codepair(p_code_dst);

	hgstrcpy((LPSTR)p_code_dst->ba_num, (LPSTR)p_code_src->ba_num);

    if(p_code_src->p_name != nnull) {
        p_code_dst->p_name = hgstrdup(p_code_src->p_name);
        if(p_code_dst->p_name == nnull) {
            hgdbgbrk;
            return ffalse;
        }
    }

	return ttrue;
}

bbool copy_codepair_data(p_codepair p_code_n, p_str p_codevalue, p_str p_codename)
{
	if((p_code_n == nnull) || (p_codevalue == nnull) || (p_codename == nnull)) {
        hgdbgbrk;
		return ffalse;
	}

    reset_codepair(p_code_n);

	hgstrncpy((LPSTR)p_code_n->ba_num, (LPSTR)p_codevalue, sizeof(p_code_n->ba_num));

    p_code_n->p_name = hgstrdup(p_codename);
    if(p_code_n->p_name == nnull) {
        hgdbgbrk;
        return ffalse;
    }

	return ttrue;
}

/*
struct strucodeinfo_fix {
	// ڵ 
	hgstr16 ba_fullcode;    // full-code
	long	stk_code;   // Ǿڵ
    bbyte   market; // Ҽӱ(ŷ, ڽ, 3)
    bbyte   gamli;  // 
    bbyte   scale;  // ںݱԸ
	bbyte   cashtime;   // 
    sint    groupcode;  // ׷ڵ
    bbyte   kospiflag;  // ڽǱ
    bbyte   admin;      // 
    bbyte   state;      // ֽĻ
    bbyte   packing1;   // 4-byte packing area
};

struct strucodeinfo {
    codepair    code;   // ڵ 
    codefxin    fixvalue;   //  
};
};
*/

bbool init_codefxin(p_codefxin p_info)
{
	if(p_info == nnull) {
		return ffalse;
	}

	hginitstring((LPSTR)p_info->ba_fullcode, sizeof(p_info->ba_fullcode), 0);    // full-code
	p_info->stk_code = 0;   // Ǿڵ
    p_info->market = market_ext_inv;// Ҽӱ(ŷ, ڽ, 3)
    p_info->gamli = gamli_ext_inv;  // 
    p_info->scale = capscale_inv;   // ںݱԸ
	p_info->cashtime = 0;   // 
    p_info->groupcode = 0;  // ׷ڵ
    p_info->kospiflag = kospi_inv;  // ڽǱ
    p_info->admin = admin_ext_inv;  // 
    p_info->state = stock_state_inv;// ֽĻ
    p_info->packing1 = 0;   // 4-byte packing area

	return ttrue;
}

bbool comp_codeinfo(p_codeinfo p_info_b, p_codeinfo p_info_n, long sortkey, p_int p_retcomp)
{
    hgassert((p_info_b != nnull) && (p_info_n != nnull) && (p_retcomp != nnull));

	if((p_info_b == nnull) || (p_info_n == nnull) || (p_retcomp == nnull)) {
        hgdbgbrk;
		return ffalse;
	}

    //
    *p_retcomp = 0;

    switch(sortkey) {
    case sortkey_codeval:   // ڵ
        // ̸  ͺ óѴ.
        // ׷ ⼭  ġ ٲ.
        *p_retcomp = hgstrcmp((p_str)p_info_b->code.ba_num, (p_str)p_info_n->code.ba_num);
        break;
    case sortkey_codename:  // ̸
        // ̸  ͺ óѴ.
        // ׷ ⼭  ġ ٲ.
    	*p_retcomp = hgstrcmp(p_info_b->code.p_name, p_info_n->code.p_name);
        break;
    default:
        hgdbgbrk;
		return ffalse;
    }

	return ttrue;
}

bbool init_codeinfo(p_codeinfo p_info)
{
	if(p_info == nnull) {
		return ffalse;
	}

    init_codepair(&p_info->code);
    init_codefxin(&p_info->fixvalue);

	return ttrue;
}

/*
struct strucodelink {
	codeinfo    value;
    // bin-link
	p_codelink  p_par;
	p_codelink  p_left;
	p_codelink  p_right;
    // double-ling
	p_codelink  p_prev;
	p_codelink  p_next;
};
*/

p_codelink create_codelink(void)
{
	p_codelink	p_infolink;

	p_infolink = (p_codelink)hgalloc(sizeof(codelink));
	if(p_infolink == nnull) {
		hgdbgbrk;
		return nnull;
	}

	if(init_codelink(p_infolink) == ffalse) {
		hgdbgbrk;
		if(free_codelink(&p_infolink) == ffalse) {
			hgdbgbrk;
		}
		return nnull;
	}

	return p_infolink;
}


bbool init_codelink(p_codelink p_infolink)
{
	if(p_infolink == nnull) {
		hgdbgbrk;
		return ffalse;
	}

	if(init_codeinfo(&p_infolink->value) == ffalse) {
		hgdbgbrk;
		return ffalse;
	}


	if(init_codelink_link(p_infolink) == ffalse) {
		hgdbgbrk;
		return ffalse;
	}

	return ttrue;
}


bbool init_codelink_link(p_codelink p_infolink)
{
	if(p_infolink == nnull) {
		hgdbgbrk;
		return ffalse;
	}

    // bin-link
    init_codelink_bin(p_infolink);
    // double-ling
    init_codelink_double(p_infolink);

	return ttrue;
}

bbool init_codelink_bin(p_codelink p_infolink)
{
	if(p_infolink == nnull) {
		hgdbgbrk;
		return ffalse;
	}

    // bin-link
	p_infolink->p_par = nnull;
	p_infolink->p_left = nnull;
	p_infolink->p_right = nnull;

	return ttrue;
}

bbool init_codelink_double(p_codelink p_infolink)
{
	if(p_infolink == nnull) {
		hgdbgbrk;
		return ffalse;
	}

    // double-ling
    p_infolink->p_prev = nnull;
	p_infolink->p_next = nnull;

	return ttrue;
}

bbool free_codelink(pp_codelink pp_infolink)
{
	if(pp_infolink == nnull) {
		hgdbgbrk;
		return ffalse;
	}

	p_codelink	p_infolink;
	p_infolink = *pp_infolink;

    if(p_infolink->value.code.p_name != nnull) {
        hgfree(p_infolink->value.code.p_name);
        p_infolink->value.code.p_name = nnull;
    }

	hgfree(p_infolink);
	p_infolink = nnull;

	*pp_infolink = nnull;

	return ttrue;
}

bbool is_codelink_3market(p_codelink p_infolink)
{
	if(p_infolink == nnull) {
		hgdbgbrk;
		return ffalse;
	}

    if(p_infolink->value.fixvalue.market != market_ext_free) {  // free-board
        return ffalse;
    }    

	return ttrue;
}

bbool is_codelink_firstitem(p_codelink p_infolink)
{
	if(p_infolink == nnull) {
		hgdbgbrk;
		return ffalse;
	}

    bbool   retst = is_firstitem((p_str)p_infolink->value.code.ba_num);
    return retst;
}

//--------------
// codegate_head
//--------------
/*
struct struCodeGateeHead {
	// checksum
	hgstr64		checksum_strn;	//  +б⿡ ȿ  ˻ ڿ
    long        checksum_num;   //  +б⿡ ȿ  ˻ 
	// ũ
    long        sortkey;// Ű
    //
	bbool       exc_3market;    // 3  
	long        sonum;  // ũ ߿ ŷ 
	long        daknum; // ũ ߿ ڽ 
	long        num3;   // ũ ߿ 3 
	long        extraup_num;// ̻޵ 
	long        admin_num;  //  
	long        stop_num;    // ŷ 
	long        lscale_num;  //  
	long        mscale_num;  //  
	long        sscale_num;  //  
	//
	long		linknum;
	//  ġ
	long		arcbeg;	// Ÿ   ġ
	long		arcend;
	// ࿵: 1024 - (4 * 11)
	BYTE		reserved[hgkbsize - (4 * sizeof(long))];
};
*/

bbool init_codehead(p_codehead p_codehead_n)
{
    hgassert(p_codehead_n != nnull);

    if(p_codehead_n == nnull) {
        return ffalse;
    }

	// checksum
	hginitstring((LPSTR)p_codehead_n->checksum_strn, sizeof(p_codehead_n->checksum_strn), 0x00);
	hgstrcpy((LPSTR)p_codehead_n->checksum_strn, checksum_basic);
    p_codehead_n->checksum_num = checksum_id_code;   //  +б⿡ ȿ  ˻ 

	// ũ
    p_codehead_n->sortkey = sortkey_codeval;// Ű
    //
	p_codehead_n->exc_3market = ffalse;    // 3  
	p_codehead_n->sonum = 0;  // ũ ߿ ŷ 
	p_codehead_n->daknum = 0; // ũ ߿ ڽ 
	p_codehead_n->num3 = 0;   // ũ ߿ 3 
	p_codehead_n->extraup_num = 0;// ̻޵ 
	p_codehead_n->admin_num = 0;  //  
	p_codehead_n->stop_num = 0;    // ŷ 
	p_codehead_n->lscale_num = 0;  //  
	p_codehead_n->mscale_num = 0;  //  
	p_codehead_n->sscale_num = 0;  //  

    //
	p_codehead_n->linknum = 0;

    //  ġ
	p_codehead_n->arcbeg = hgpos_inv;	// Ϻ Ÿ   ġ
	p_codehead_n->arcend = hgpos_inv;

    // ࿵: 1024 - (4 * 11)
	hginitstring((LPSTR)p_codehead_n->reserved, sizeof(p_codehead_n->reserved), 0x00);

    return ttrue;
}

bbool reset_codehead(p_codehead p_codehead_n)
{
    hgassert(p_codehead_n != nnull);

    if(p_codehead_n == nnull) {
        hgdbgbrk;
        return ffalse;
    }

    if(init_codehead(p_codehead_n) == ffalse) {
        hgdbgbrk;
        return ffalse;
    }

    return ttrue;
}


//--------
// codegate
//--------
codegate::codegate(p_codegate p_codegate_b /* = nnull */, long sortkey_b /* = sortkey_invalid */)
{
    init();

    // ϴ ˻
    if(p_codegate_b != nnull) {
        //   ش.
        if(sortkey_b == sortkey_invalid) {
            //   Ű  ȿ̸ p_codegate_b  Ű ̾޴´.
            this->m_codehead.sortkey = p_codegate_b->m_codehead.sortkey;
        }
        else {
            this->m_codehead.sortkey = sortkey_b;
        }
    
        // 
	    p_codelink	lpCurRec;
    	
	    lpCurRec = p_codegate_b->p_head;
	    while(lpCurRec) {
            if(this->append((p_str)lpCurRec->value.code.ba_num, 
                lpCurRec->value.code.p_name, &lpCurRec->value.fixvalue) == ffalse) {
			    hgdbgbrk;
                break;
		    }
    	
		    lpCurRec = lpCurRec->p_next;
	    }

        //  ũ ȭŲ.
        // - 뷮 ݺ Ž ӵ  ش.
        this->centering_link();

        // ڵ׷/(׸)
        hgstrncpy((p_str)this->m_codehead.ba_gatename, 
            (p_str)p_codegate_b->m_codehead.ba_gatename, 
            sizeof(this->m_codehead.ba_gatename));
    }
    else {
        //   Ѿ  Ű Ѱִ Ȯ
        if(sortkey_b != sortkey_invalid) {
            this->m_codehead.sortkey = sortkey_b;
        }
    }
}

codegate::~codegate()
{
    reset();
}

bbool codegate::init()
{
    if(init_codehead(&this->m_codehead) == ffalse) {
        hgdbgbrk;
        return ffalse;
    }

	// ũ
	this->init_link();

    return ttrue;
}

void codegate::init_link()
{
	this->p_top = nnull;
	this->p_head = nnull;
	this->p_tail = nnull;
}

bbool codegate::reset(void)
{
	p_codelink	lpCurRec, lpNewRec;
	
    if(reset_codehead(&this->m_codehead) == ffalse) {
        hgdbgbrk;
        return ffalse;
    }


    //
	lpCurRec = this->p_head;
	
	while(lpCurRec) {
		lpNewRec = lpCurRec->p_next;

		if(free_codelink(&lpCurRec) == ffalse) {
			hgdbgbrk;
            break;
		}
        lpCurRec = nnull;
	
		lpCurRec = lpNewRec;
	}

	//
    init();

    return ttrue;
}

bbool codegate::append(p_codelink p_new)
{
	p_codelink  p_curpos, p_loop;

    hgassert(p_new != nnull);

	if(p_new == nnull) {
		return ffalse;
	}

	// [p_new] õ ũ(θ,,,,) ʱȭѴ.
	// 쿡 󼭴 ʱȭ    ´.
	init_codelink_link(p_new);

	p_curpos = p_top;
	if(p_curpos == nnull) {
		p_head = p_new;
		p_tail = p_new;
		p_top = p_new;
	}
    else {
        p_loop = nnull;
	    while(p_curpos) {
            if((p_loop != nnull) && (p_loop == p_curpos)) {
                HGMsgBox_Err(" (loop) ϴ.");
                return false;
            }
            p_loop = p_curpos;

            int     compval;

            if(comp_codeinfo(&p_curpos->value, &p_new->value, this->m_codehead.sortkey, &compval) == ffalse) {
                hgdbgbrk;
                return ffalse;
            }
            if(compval > 0) {
                if(p_curpos->p_left == nnull) {
				    p_new->p_par = p_curpos;
				    p_curpos->p_left = p_new;
    				
                    if(p_curpos->p_prev) {
                        p_curpos->p_prev->p_next = p_new;
                        p_new->p_prev = p_curpos->p_prev;
                        p_curpos->p_prev = p_new;
                        p_new->p_next = p_curpos;
                    }
                    else {
                        p_curpos->p_prev = p_new;
                        p_new->p_next = p_curpos;
            		    p_head = p_new;
                    }
				    break;
			    }
    				
			    p_curpos = p_curpos->p_left;
		    }
		    else {
			    if(p_curpos->p_right == nnull) {
                    p_new->p_par = p_curpos;
				    p_curpos->p_right = p_new;

                    if(p_curpos->p_next) {
                        p_curpos->p_next->p_prev = p_new;
                        p_new->p_next = p_curpos->p_next;
                        p_curpos->p_next = p_new;
                        p_new->p_prev = p_curpos;
                    }
                    else {
                        p_curpos->p_next = p_new;
                        p_new->p_prev = p_curpos;
            		    p_tail = p_new;
                    }
				    break;
			    }
    				
			    p_curpos = p_curpos->p_right;
		    }
	    }
    }

    //
    this->m_codehead.linknum++;

    //------------------
    //  ׸ ߰
    //------------------
    //-------------------------------------------------
    // 2008.11.18. ̺  Ǹ鼭 ٲ.
    // -  ڵ ܵд.
    //-------------------------------------------------
    //-switch(p_new->value.fixvalue.market) {
    //-case market_so:
    //-    // ڽ ׸ ߰
    //-    this->m_codehead.sonum++;
    //-    break;
    //-case market_dak:
    //-    // ŷ ׸ ߰
    //-    this->m_codehead.daknum++;
    //-    break;
    //-case market_3: // 3
    //-    this->m_codehead.num3++;
    //-    break;
    //-case market_unk2:// '4' // ˷   ִ. {ȣ-ŷҷ }
    //-case market_unk1://'7' // ˷   ִ.
    //-    break;
    //-default:
    //-    hgdbgbrk;
    //-    return ffalse;
    //-}
    //-------------------------------------------------
    switch(p_new->value.fixvalue.market) {
    case market_ext_so:
        // ڽ ׸ ߰
        this->m_codehead.sonum++;
        break;
    case market_ext_dak:
        // ŷ ׸ ߰
        this->m_codehead.daknum++;
        break;
    case market_ext_free: // 3
        this->m_codehead.num3++;
        break;
    case market_ext_krx: // krx
        this->m_codehead.num3++;
        break;
    default:
        hgdbgbrk;
        return ffalse;
    }

    // 
    switch(p_new->value.fixvalue.gamli) {
    case gamli_ext_norm:    // 
        break;
    case gamli_ext_attention:   // 
    case gamli_ext_warning:     // 
    case gamli_ext_danger_notice:   // 迹
    case gamli_ext_danger:          // 
    	this->m_codehead.extraup_num++;// ̻޵ 
        break;
    default:
        hgdbgbrk;
        return ffalse;
    }

    // 
    switch(p_new->value.fixvalue.admin) {
    case admin_ext_none:    // Ϲ
        break;
    case admin_ext_yes:     // 
    	this->m_codehead.admin_num++;//  
        break;
    default:
        hgdbgbrk;
        return ffalse;
    }

    // ֽĻ
    switch(p_new->value.fixvalue.state) {
    case stock_state_norm:  // 
    case stock_state_break: // ŷ-߿ Ͻ 
        break;
    case stock_state_stop:  // ŷ
        this->m_codehead.stop_num++;   // ŷ 
        break;
    default:
        hgdbgbrk;
        return ffalse;
    }

    // Ը 
    switch(p_new->value.fixvalue.scale) {
    case capscale_big:  // 
	    this->m_codehead.lscale_num++;  //  
        break;
    case capscale_mid:  // 
	    this->m_codehead.mscale_num++;  //  
        break;
    case capscale_small:    // 
        this->m_codehead.sscale_num++;  //  
        break;
    case capscale_non:  // Ϻ  ں Ը .
        //- ׳ 
        break;
    default:
        hgdbgbrk;
        return ffalse;
    }
	
    return ttrue;
}

bbool codegate::append(p_str p_codeval, p_str p_codename, p_codefxin p_fixvalue)
{
	hgassert((p_codeval != nnull) && (p_codename != nnull) && (p_fixvalue != nnull));

    if((p_codeval == nnull) || (p_codename == nnull) || (p_fixvalue == nnull)) {
        hgdbgbrk;
        return ffalse;
    }

    //
	p_codelink	p_info;
	
	p_info = create_codelink();
	if(p_info == nnull) {
		hgdbgbrk;
		return ffalse;
	}

	//
    hgstrncpy((p_str)p_info->value.code.ba_num, p_codeval, sizeof(p_info->value.code.ba_num));

    p_info->value.code.p_name = hgstrdup(p_codename);
    if(p_info->value.code.p_name == nnull) {
        hgdbgbrk;
        goto exit_pos;
    }

    p_info->value.fixvalue = *p_fixvalue;

	//
	if(this->append(p_info) == ffalse) {
exit_pos:
		hgdbgbrk;
		if(free_codelink(&p_info) == ffalse) {
			hgdbgbrk;
		}
		return ffalse;
	}

	return ttrue;
}

bbool codegate::unlink(p_codelink p_unlik)
{
	p_codelink  lpCurRec, lpPreRec, lpRepRec, lpParRec, lpSonRec;

    // init
    lpRepRec = nnull;
    lpParRec = nnull;
    lpSonRec = nnull;

	lpCurRec = p_top;
	lpPreRec = NULL;
	while(lpCurRec) {
		if(lpCurRec == p_unlik) {
			break;
		}
		lpPreRec = lpCurRec;

        int compval;
        if(comp_codeinfo(&lpCurRec->value, &p_unlik->value, this->m_codehead.sortkey, &compval) == ffalse) {
            hgdbgbrk;
            return ffalse;
        }
        if(compval > 0) {
			lpCurRec = lpCurRec->p_left;
		}
		else {
			lpCurRec = lpCurRec->p_right;
		}
	}
	if(lpCurRec == NULL) {
        HGMsgBox_Err("Ϸ ޸  شϴ  ϴ.");
		return false;	// not-exist
	}
	
    if(lpCurRec->p_left == NULL) {
    	lpRepRec = lpCurRec->p_right;
    }
    else {
    	if(lpCurRec->p_right == NULL) {
	    	lpRepRec = lpCurRec->p_left;
    	}
    	else {
    		lpParRec = lpCurRec;
    		lpRepRec = lpCurRec->p_right;
    		lpSonRec = lpRepRec->p_left;
    	
    		while(lpSonRec) {
	    		lpParRec = lpRepRec;
	    		lpRepRec = lpSonRec;
	    		lpSonRec = lpRepRec->p_left;
    		}
    		
    		if(lpParRec != lpCurRec) {
    			lpParRec->p_left = lpRepRec->p_right;
    			lpRepRec->p_right = lpCurRec->p_right;
    		}
    		
    		lpRepRec->p_left = lpCurRec->p_left;
    	}
    }
    
    if(lpPreRec == NULL) {
    	p_top = lpRepRec;
    }
    else {
    	if(lpCurRec == lpPreRec->p_left) {
    		lpPreRec->p_left = lpRepRec;
    	}
    	else {
    		lpPreRec->p_right = lpRepRec;
    	}
    }
	
	//  ũ óѴ.
	if(lpCurRec == p_head) {
		if(lpCurRec == p_tail) {
			hgassert(this->m_codehead.linknum == 1);

			p_head = nnull;
			p_tail = nnull;
		}
		else {
			p_head = lpCurRec->p_next;
			p_head->p_prev = nnull;
		}
	}
	else if(lpCurRec == p_tail) {
		hgassert(this->m_codehead.linknum > 1);

		if(lpCurRec == p_head) {
			// ٷ տ ˻߱    .
			hgdbgbrk;

			p_head = nnull;
			p_tail = nnull;
		}
		else {
			p_tail = lpCurRec->p_prev;
			p_tail->p_next = nnull;
		}
	}
	else {
		hgassert(this->m_codehead.linknum > 1);

		lpPreRec = lpCurRec->p_prev;
		lpSonRec = lpCurRec->p_next;

		lpPreRec->p_next = lpSonRec;
		lpSonRec->p_prev = lpPreRec;
	}

    this->m_codehead.linknum--;

    //------------------
    //  ׸ 
    //------------------
    //-------------------------------------------------
    // 2008.11.18. ̺  Ǹ鼭 ٲ.
    // -  ڵ ܵд.
    //-------------------------------------------------
    //-switch(p_unlik->value.fixvalue.market) {
    //-case market_so:
    //-    // ڽ ׸ 
    //-    this->m_codehead.sonum--;
    //-    break;
    //-case market_dak:
    //-    // ŷ ׸
    //-    this->m_codehead.daknum--;
    //-    break;
    //-case market_3: // 3
    //-    this->m_codehead.num3--;
    //-    break;
    //-case market_unk2:// '4' // ˷   ִ. {ȣ-ŷҷ }
    //-case market_unk1://'7' // ˷   ִ.
    //-    break;
    //-default:
    //-    hgdbgbrk;
    //-    return ffalse;
    //-}
    //-------------------------------------------------
    switch(p_unlik->value.fixvalue.market) {
    case market_ext_so:
        // ڽ ׸ ߰
        this->m_codehead.sonum++;
        break;
    case market_ext_dak:
        // ŷ ׸ ߰
        this->m_codehead.daknum++;
        break;
    case market_ext_free: // 3
        this->m_codehead.num3++;
        break;
    case market_ext_krx: // krx
        this->m_codehead.num3++;
        break;
    default:
        hgdbgbrk;
        return ffalse;
    }

    // 
    switch(p_unlik->value.fixvalue.gamli) {
    case gamli_ext_norm:    // 
        break;
    case gamli_ext_attention:   // 
    case gamli_ext_warning:     // 
    case gamli_ext_danger_notice:   // 迹
    case gamli_ext_danger:          // 
    	this->m_codehead.extraup_num++;// ̻޵ 
        break;
    default:
        hgdbgbrk;
        return ffalse;
    }

    // 
    switch(p_unlik->value.fixvalue.admin) {
    case admin_ext_none:    // Ϲ
        break;
    case admin_ext_yes:     // 
    	this->m_codehead.admin_num++;//  
        break;
    default:
        hgdbgbrk;
        return ffalse;
    }

    // ֽĻ
    switch(p_unlik->value.fixvalue.state) {
    case stock_state_norm:  // 
    case stock_state_break: // ŷ-߿ Ͻ 
        break;
    case stock_state_stop:  // ŷ
        this->m_codehead.stop_num++;   // ŷ 
        break;
    default:
        hgdbgbrk;
        return ffalse;
    }

    // Ը 
    switch(p_unlik->value.fixvalue.scale) {
    case capscale_big:  // 
	    this->m_codehead.lscale_num--;  //  
        break;
    case capscale_mid:  // 
	    this->m_codehead.mscale_num--;  //  
        break;
    case capscale_small:    // 
        this->m_codehead.sscale_num--;  //  
        break;
    case capscale_non:  // Ϻ  ں Ը .
        //- ׳ 
        break;
    default:
        hgdbgbrk;
        return ffalse;
    }

    //--------------------------
    // Linũ ʱȭѴ.
	init_codelink_link(lpCurRec);

    return true;
}

bbool codegate::del(p_codelink p_del)
{
    hgassert(p_del != nnull);

    if(p_del == nnull) {
        return ffalse;
    }
	if(this->unlink(p_del) == ffalse) {
		hgdbgbrk;
        return ffalse;
	}

	if(free_codelink(&p_del) == ffalse) {
		hgdbgbrk;
        return ffalse;
	}
    p_del = nnull;
	
    return true;
}

long codegate::get_sortkey()
{
    return this->m_codehead.sortkey;
}

void codegate::set_sortkey(long sortkey)
{
    switch(sortkey) {
    case sortkey_codeval:   // ڵ
    case sortkey_codename:  // ̸
        this->m_codehead.sortkey = sortkey;
        break;
    default:
        hgdbgbrk;
		return ;
    }
}

long codegate::get_exc_3market()
{
    return this->m_codehead.exc_3market;
}

void codegate::set_exc_3market(bbool exc_3market)
{
    this->m_codehead.exc_3market = exc_3market;
}

p_str codegate::get_groupname()
{
    return (p_str)this->m_codehead.ba_gatename;
}

bbool codegate::set_groupname(p_str p_groupname)
{
    hgassert(p_groupname != nnull);

    if(p_groupname == nnull) {
        hgdbgbrk;
        return ffalse;
    }
    
    hgstrncpy((p_str)this->m_codehead.ba_gatename, 
        p_groupname, sizeof(this->m_codehead.ba_gatename));

    return ttrue;
}

long codegate::get_linknum()
{
    return this->m_codehead.linknum;
}

long codegate::get_linknum_so()
{
    return this->m_codehead.sonum;
}

long codegate::get_linknum_dak()
{
    return this->m_codehead.daknum;
}

long codegate::get_linknum_3()
{
    return this->m_codehead.num3;
}

p_codelink codegate::get_top()
{
    return this->p_top;
}

p_codelink codegate::get_head()
{
    return this->p_head;
}

p_codelink codegate::get_tail()
{
    return this->p_tail;
}

long codegate::find_recorder(p_codelink p_cur)
{
	p_codelink p_code;
	long      Order;

	hgassert(p_cur != nnull);

    if(p_cur == nnull) {
		return hgpos_inv;
	}

    Order = 0;
	p_code = this->p_head;
	while(p_code) {
        Order++;
        if(p_code == p_cur) {
            return Order;
        }
        
        p_code = p_code->p_next;
    }

    //    .
    hgdbgbrk;
	return hgpos_inv;
}

p_codelink codegate::find_codeval(p_str p_codeval)
{
    hgassert(p_codeval != nnull);

    if(p_codeval == nnull) {
        return nnull;
    }
    if(hgstrlen(p_codeval) <= 0) {
        hgdbgbrk;
        return nnull;
    }

    //
	p_codelink  p_curpos, p_loop;

    if(this->get_sortkey() == sortkey_codeval) {  // ڵ - Ž
	    p_curpos = p_top;
        p_loop = nnull;
	    while(p_curpos) {
            if((p_loop != nnull) && (p_loop == p_curpos)) {
                HGMsgBox_Err(" (loop) ϴ.");
                return nnull;
            }
            p_loop = p_curpos;

            int     compval;

            compval = hgstrcmp((p_str)p_curpos->value.code.ba_num, p_codeval);
            if(compval == 0) {
                return p_curpos;
            }
            else if(compval > 0) {
                if(p_curpos->p_left == nnull) {
				    break;
			    }
        			
			    p_curpos = p_curpos->p_left;
		    }
		    else {
			    if(p_curpos->p_right == nnull) {
				    break;
			    }
        			
			    p_curpos = p_curpos->p_right;
		    }
	    }
    }
    else {  // Ž
	    p_curpos = this->p_head;
	    while(p_curpos) {
            if(hgstrcmp((p_str)p_curpos->value.code.ba_num, p_codeval) == 0) {
                return p_curpos;
            }

            //
            p_curpos = p_curpos->p_next;
        }
    }

    //-----------------------------
    //   ã 쵵 ϰ ִ.
    // ã  ٰ  ƴϴ.
    //-----------------------------
    //-//    .
    //-hgdbgbrk;
    //-----------------------------
	return nnull;
}

p_codelink codegate::find_codename(p_str p_codename)
{
    hgassert(p_codename != nnull);

    if(p_codename == nnull) {
        return nnull;
    }
    if(hgstrlen(p_codename) <= 0) {
        hgdbgbrk;
        return nnull;
    }

    //
	p_codelink  p_code;
    //-int         dbg_cnt = 0;

	p_code = this->p_head;
	while(p_code) {
		if(hgstrcmp(p_code->value.code.p_name, p_codename) == 0) {
            return p_code;
        }

        //
        p_code = p_code->p_next;
        //-dbg_cnt++;
    }

    //-----------------------------
    // ڵ Ͽ   Ȯϴ 쵵 ִ.
    // ׷Ƿ  ޽  ʴ´.
    //-----------------------------
    //-//    .
    //-hgdbgbrk;
    //-----------------------------
	return nnull;
}

p_codelink codegate::drag_entrylink(hgpos LocPos)
{
	p_codelink lpMrec_Cur;
	long			Cnt;

	hgassert((LocPos > hgpos_inv) && (LocPos <= this->get_linknum()));

    if((LocPos <= hgpos_inv) || (LocPos > this->get_linknum())) {
		return nnull;
	}

	if(p_head == nnull) {
        hgdbgbrk;
		return nnull;
	}
	
	Cnt = 0;
	lpMrec_Cur = this->p_head;
	while(lpMrec_Cur) {
		if(Cnt == LocPos) {
			return lpMrec_Cur;
		}
	
        Cnt++;
		lpMrec_Cur = lpMrec_Cur->p_next;
	}

	return nnull;
}

p_str codegate::make_codeval_string(hgpos locbeg, long makenum, p_long p_makenum)
{
    hgassert((locbeg > hgpos_inv) && (makenum > 0) && 
        (makenum <= stockmst2_max) && (p_makenum != nnull));

    if((locbeg <= hgpos_inv) || (makenum <= 0) || 
        (makenum > stockmst2_max) || (p_makenum == nnull)) {
        hgdbgbrk;
        return nnull;
    }

    // init
    *p_makenum = 0;
    
    //
    int         cnt, strsum, strpos, curlen;
    p_str       p_retstr;
    p_codelink  p_cur, p_work;

    //  ġ ̵Ų.
    cnt = 0;
    p_cur = this->p_head;

    while(cnt < locbeg) {
        if(p_cur == nnull) {
            hgdbgbrk;
            return nnull;
        }

        //
        cnt++;
        p_cur = p_cur->p_next;
    }

    // codeval  ü ڿ ̸ Ѵ.
    cnt = 0;
    strsum = 0;
    p_retstr = nnull;
    p_work = p_cur; //  ۾ ؼ  ũ صд.

    while(cnt < makenum) {
        if(p_cur == nnull) {
            //   ׸  
            // -  ƴϴ. ׸   Ⱚ  ʱ ̴.
            //-hgdbgbrk;
            break;
        }

        curlen = hgstrlen((p_str)p_cur->value.code.ba_num);
        if(curlen <= 0) {
            hgdbgbrk;
            return nnull;
        }
        strsum += curlen;

        //
        cnt++;
        p_cur = p_cur->p_next;
    }

    //
    if(strsum <= 0) {
        // ׸ ϳ     
        // - ̸ ϰ Ա  ּ 1 ׸̶ ־ ̴.
        hgdbgbrk;
        return nnull;
    }

    //----------------------------------------------------
    // ޸𸮸 ҴϿ codeval Ŀ ° Ѱش.
    //----------------------------------------------------
    strsum += cnt;  // stocmst2 code ϴ (,)  ߰
    p_retstr = (p_str)hgalloc(strsum + 1);
    if(p_retstr == nnull) {
        hgdbgbrk;
        return nnull;
    }

    cnt = 0;
    strpos = 0;

    while(cnt < makenum) {
        if(p_work == nnull) {
            //   ׸  
            // -  ƴϴ. ׸   Ⱚ  ʱ ̴.
            //-hgdbgbrk;
            break;
        }

        curlen = hgstrlen((p_str)p_work->value.code.ba_num);
        if(curlen <= 0) {
            hgdbgbrk;
            return nnull;
        }
        hgstrcpy(&p_retstr[strpos], (p_str)p_work->value.code.ba_num);
        strpos += curlen;
        p_retstr[strpos++] = stockdelimt;

        //
        cnt++;
        p_work = p_work->p_next;
    }
    if(strsum != strpos) {
        hgdbgbrk;
        hgfree(p_retstr);
        p_retstr = nnull;
        return p_retstr;
    }

    //   ڵ屸а پִµ ̰ ش.
    p_retstr[strpos - 1] = 0x00;

    // result
    *p_makenum = cnt;

    return p_retstr;
}

bbool codegate::del_doublecode()
{
    //----------------------------------------------------
    // Ư 뵵 Ѵ.
    //  ü ڵ   ʰ
    // ÿ  ׷  ޾Ƽ ϳ   
    // ߺ ڵ带 ܽŰ ؼ Ѵ.
    // ׷ Ű ϰ Ѵ.
    //----------------------------------------------------
    switch(this->m_codehead.sortkey) {
    case sortkey_codeval:   // ڵ
    case sortkey_codename:  // ̸
        break;
    default:
        //  Ű  Լ   .
        hgdbgbrk;
        return ffalse;
    }

	p_codelink  lpCurRec, lpNextRec;

    // init
	lpCurRec = this->p_head;
	while(lpCurRec) {
        lpNextRec = lpCurRec->p_next;
        if(lpNextRec == nnull) {
            if(lpCurRec != this->p_tail) { //  
                hgdbgbrk;
                return ffalse;
            }
            //    -  ̻ ߺ ڵ尪 .
            break;
        }

        int compval;
        switch(this->m_codehead.sortkey) {
        case sortkey_codeval:   // ڵ
            compval = hgstrcmp((p_str)lpCurRec->value.code.ba_num, 
                                (p_str)lpNextRec->value.code.ba_num);
            break;
        case sortkey_codename:  // ̸
            compval = hgstrcmp(lpCurRec->value.code.p_name, 
                                lpNextRec->value.code.p_name);
            break;
        default:
            //  Ű  Լ   .
            hgdbgbrk;
            return ffalse;
        }
        if(compval == 0) {
            //   ߰ߵǸ   .
            // ڿ    ֽ  ɼ .
            if(this->del(lpCurRec) == ffalse) {
                hgdbgbrk;
                return ffalse;
            }
        }
		lpCurRec = lpNextRec;
	}
	
    //  ũ ȭŲ.
    // - 뷮 ݺ Ž ӵ  ش.
    this->centering_link();

    return true;
}

bbool codegate::del_firstitem()
{
    // 켱ָ ش.
    switch(this->m_codehead.sortkey) {
    case sortkey_codeval:   // ڵ
    case sortkey_codename:  // ̸
        break;
    default:
        //  Ű  Լ   .
        hgdbgbrk;
        return ffalse;
    }

	p_codelink  lpCurRec, lpNextRec;

    // init
	lpCurRec = this->p_head;
	while(lpCurRec) {
        lpNextRec = lpCurRec->p_next;
        if(lpNextRec == nnull) {
            if(lpCurRec != this->p_tail) { //  
                hgdbgbrk;
                return ffalse;
            }
            //    -  ̻ ߺ ڵ尪 .
            break;
        }

        //
        if(is_codelink_firstitem(lpCurRec) == ttrue) {
            if(this->del(lpCurRec) == ffalse) {
                hgdbgbrk;
                return ffalse;
            }
        }

        //
		lpCurRec = lpNextRec;
	}
	
    //  ũ ȭŲ.
    // - 뷮 ݺ Ž ӵ  ش.
    this->centering_link();

    return true;
}

bool codegate::centering_link()
{
    p_codelink  lpHead, lpTail;
    hgnum       RecNum;

	RecNum = this->m_codehead.linknum;
    if(RecNum <= hgnum_inv) {
		return true;
	}

	// Bin-Link ´.
	if(this->unlink_binlink() == false) {
		hgdbgbrk;
		return false;
	}

	// óѴ.
	lpHead = p_head;
	lpTail = p_tail;

	p_top = this->binize_link(lpHead, lpTail, RecNum);
	if(p_top == nnull) {
		hgdbgbrk;
		return false;
	}

	return true;
}

bool codegate::unlink_binlink()
{
	p_codelink  lpLink;
	hgnum       RecNum;

    //
	RecNum = this->m_codehead.linknum;
	if(RecNum <= 0) {
		return true;
	}

	// Bin-Link ´.
	lpLink = this->p_head;
	while(lpLink) {
        if(init_codelink_bin(lpLink) == ffalse) {
            hgdbgbrk;
            return ffalse;
        }

        lpLink = lpLink->p_next;
	}

	return true;
}

p_codelink codegate::binize_link(p_codelink lpHead, p_codelink lpTail, hgnum RecNum)
{
	p_codelink  lpMid, lpSubMid, lpSubHead, lpSubTail;
	hgnum       HalfPos, HalfRecNum;

	hgassert((lpHead != nnull) && (lpTail != nnull) && (RecNum > 0));

	if((lpHead == nnull) || (lpTail == nnull) || (RecNum <= 0)) {
		return nnull;
	}

	if(RecNum == 1) {
		hgassert(lpHead == lpTail);
		
		return lpHead;
	}
	else if(RecNum == 2) {
		hgassert(lpHead->p_next == lpTail);

		lpTail->p_left = lpHead;
		lpHead->p_par = lpTail;

		return lpTail;
	}
	else if(RecNum > 2) {
		lpMid = get_midlink(lpHead, lpTail, RecNum, &HalfPos);
		if(lpMid == nnull) {
			hgdbgbrk;
			return nnull;
		}

		// lpLeft .
		lpSubHead = lpHead;
		lpSubTail = lpMid->p_prev;
		HalfRecNum = (HalfPos - 1);

		lpSubMid = this->binize_link(lpSubHead, lpSubTail, HalfRecNum);
		if(lpSubMid == nnull) {
			hgdbgbrk;
			return nnull;
		}
		lpMid->p_left = lpSubMid;
		lpSubMid->p_par = lpMid;

		// lpRight .
		lpSubHead = lpMid->p_next;
		lpSubTail = lpTail;
		HalfRecNum = (RecNum - HalfPos);

		lpSubMid = this->binize_link(lpSubHead, lpSubTail, HalfRecNum);
		if(lpSubMid == nnull) {
			hgdbgbrk;
			return nnull;
		}
		lpMid->p_right = lpSubMid;
		lpSubMid->p_par = lpMid;

		return lpMid;
	}

	return nnull;
}

p_codelink codegate::get_midlink(p_codelink lpHead, p_codelink lpTail, 
									 hgnum RecNum, LPHGNUM lpMidWordPos)
{
	p_codelink  lpMid;
	hgnum       HalfPos, Cnt;

	hgassert((lpHead != nnull) && (lpTail != nnull) && (lpMidWordPos != nnull) && (RecNum > 0));

	if((lpHead == nnull) || (lpTail == nnull) || (lpMidWordPos == nnull) || (RecNum <= 0)) {
		return nnull;
	}

	// ߰ ġ Ѵ.
	HalfPos = ((hgnum)(RecNum / 2)) + 1;
	if(HalfPos < 1) {
		hgdbgbrk;
		return nnull;
	}
	*lpMidWordPos = HalfPos;
	
	if(HalfPos == 1) {
		if(lpHead != lpTail) {
			hgdbgbrk;
			return nnull;
		}
		return lpHead;
	}
	else {
		lpMid = lpHead;

		for(Cnt = 1; Cnt < HalfPos; Cnt++) {
            if(lpMid == nnull) {
                hgdbgbrk;
                return nnull;
            }

			lpMid = lpMid->p_next;
		}
	
		return lpMid;
	}

	return nnull;	//  ؼ
}

bbool codegate::write(p_str p_file)
{
    hgassert(p_file != nnull);

    if(p_file == nnull) {
        return ffalse;
    }

    bbool   retst = ffalse;
    hfile   hfile_work;

    hfile_work = HGFileCreate(p_file, FILE_CREATE_MODE);
    if(hfile_work == hfile_error) {
        hgdbgbrk;
        return ffalse;
    }

    retst = this->write(hfile_work);
    hgfileclose(hfile_work);
    if(retst == ffalse) {
        hgdbgbrk;
        return retst;
    }
    
    return retst;

}

bbool codegate::write(hfile hfile_work)
{
    hgassert(hfile_work != hfile_error);

    if(hfile_work == hfile_error) {
        hgdbgbrk;
        return ffalse;
    }

    bbool   retst = ffalse;
    long    arcbeg_save;

    //------------
    //  
    //------------
    //    ġ صд.
    // codegate ۰ ܺο   
    //   codegate ġ ˾ƾ Ѵ.
    arcbeg_save = HGFP_CUR(hfile_work);

    if(hgfilewrite(hfile_work, &this->m_codehead, 
        sizeof(this->m_codehead)) != sizeof(this->m_codehead)) {
        hgdbgbrk;
        return ffalse;
    }

    //
    int         workcnt;
	p_codelink  p_worker;

    //----------
    //  
    //----------
    workcnt = 0;
    p_worker = this->p_head;
    this->m_codehead.arcbeg = HGFP_CUR(hfile_work);

    while(p_worker != nnull) {
        //
        workcnt++;

        if(hgfilewrite(hfile_work, &p_worker->value, 
            sizeof(p_worker->value)) != sizeof(p_worker->value)) {
            hgdbgbrk;
            return ffalse;
        }
        int name_len = hgstrlen((LPCSTR)p_worker->value.code.p_name);
        if(hgfilewrite(hfile_work, &name_len, sizeof(name_len)) != sizeof(name_len)) {
            hgdbgbrk;
            return ffalse;
        }
        if(hgfilewrite(hfile_work, p_worker->value.code.p_name, name_len) != name_len) {
            hgdbgbrk;
            return ffalse;
        }

        //
        p_worker = p_worker->p_next;
    }
    if(workcnt != this->m_codehead.linknum) {
        hgdbgbrk;
        return ffalse;
    }

    //
    this->m_codehead.arcend = HGFP_CUR(hfile_work);
    HGFP_SET(hfile_work, arcbeg_save);
    
    if(hgfilewrite(hfile_work, &this->m_codehead, 
        sizeof(this->m_codehead)) != sizeof(this->m_codehead)) {
        hgdbgbrk;
        return ffalse;
    }

    //
    retst = ttrue;

    return retst;
}

bbool codegate::read(p_str p_file, long sortkey_b /* = sortkey_invalid */, bbool exc_3market /* = ttrue */)
{
    hgassert(p_file != nnull);

    if(p_file == nnull) {
        return ffalse;
    }

    //
    this->reset();
    
    if(sortkey_b != sortkey_invalid) {
        this->set_sortkey(sortkey_b);
    }

    //
    bbool   retst = ffalse;
    hfile   hfile_work;

    hfile_work = HGFileOpen(p_file, READ);
    if(hfile_work == hfile_error) {
        hgdbgbrk;
        return ffalse;
    }

    retst = this->read(hfile_work, sortkey_b, exc_3market);
    hgfileclose(hfile_work);
    
    if(retst == ffalse) {
        hgdbgbrk;
        return ffalse;
    }

    //
    retst = ttrue;

    return retst;

}

bbool codegate::read(hfile hfile_work, long sortkey_b /* = sortkey_invalid */, bbool exc_3market /* = ttrue */)
{
    hgassert(hfile_work != hfile_error);

    if(hfile_work == hfile_error) {
        return ffalse;
    }

    //
    this->reset();
    
    if(sortkey_b != sortkey_invalid) {
        this->set_sortkey(sortkey_b);
    }

    //
    bbool   retst = ffalse;

    //------------
    //  б
    //------------
    codehead    codehead_r;

    if(hgfileread(hfile_work, &codehead_r, 
        sizeof(codehead_r)) != sizeof(codehead_r)) {
        hgdbgbrk;
        return ffalse;
    }

    //  ´ Ȯ - checksum ˻
    if(hgstrncmp((p_str)codehead_r.checksum_strn, checksum_basic, hgstrlen(checksum_basic)) != 0) {
        hgdbgbrk;
        return ffalse;
    }
    if(codehead_r.checksum_num != checksum_id_code) {    
        //  +б⿡ ȿ  ˻ 
        hgdbgbrk;
        return ffalse;
    }

    //
    int         workcnt;

    //
    workcnt = 0;

    while(workcnt < codehead_r.linknum) {
        //
        codeinfo    codeinfo_r;
        hgstr256    codename;

        if(hgfileread(hfile_work, &codeinfo_r, 
            sizeof(codeinfo_r)) != sizeof(codeinfo_r)) {
            hgdbgbrk;
            return ffalse;
        }


        int     name_len;
        if(hgfileread(hfile_work, &name_len, sizeof(name_len)) != sizeof(name_len)) {
            hgdbgbrk;
            return ffalse;
        }
        if(name_len <= 0) {
            hgdbgbrk;
            return ffalse;
        }
        if(hgfileread(hfile_work, (LPSTR)codename, name_len) != name_len) {
            hgdbgbrk;
            return ffalse;
        }
        codename[name_len] = 0x00;

        //
        if(this->append((p_str)codeinfo_r.code.ba_num, (p_str)codename, &codeinfo_r.fixvalue) == ffalse) {
            hgdbgbrk;
            return ffalse;
        }

        //
        workcnt++;
    }
    if(workcnt != this->m_codehead.linknum) {
        hgdbgbrk;
        return ffalse;
    }

    //
    retst = ttrue;

    //  ũ ȭŲ.
    // - 뷮 ݺ Ž ӵ  ش.
    this->centering_link();

    //  3  ϴ ˻
    if(exc_3market == ttrue) {
        if(this->exc_3market() < 0) {
            // '0'  
            hgdbgbrk;
            retst = ffalse;
        }
    }

    return retst;
}

hgnum codegate::exc_3market()
{
    // return : (-1)  

    int         extnum;
	p_codelink  p_code, p_next;

    extnum = 0;
	p_code = this->p_head;
	while(p_code != nnull) {
        if(is_codelink_3market(p_code) == ttrue) {
            p_next = p_code->p_next;

            if(this->del(p_code) == ffalse) {
                hgdbgbrk;
                return (-1);
            }

            extnum++;
            p_code = p_next;
        }
        else {
            p_code = p_code->p_next;
        }
    }

    //  3 ׸  3  ¸ ش.
    if(extnum > 0) {
        this->set_exc_3market(ttrue);
    }

    //  ũ ȭŲ.
    // - 뷮 ݺ Ž ӵ  ش.
    this->centering_link();

    return extnum;
}

bbool codegate::export_txt(p_str p_file, bbool only_codval /* = ffalse */)
{
    hgassert(p_file != nnull);

    if(p_file == nnull) {
        return ffalse;
    }

    bbool   retst = ffalse;
    hfile   hfile_work;

    hfile_work = HGFileCreate(p_file, FILE_CREATE_MODE);
    if(hfile_work == hfile_error) {
        hgdbgbrk;
        return ffalse;
    }

    retst = this->export_txt(hfile_work, only_codval);
    hgfileclose(hfile_work);
    if(retst == ffalse) {
        hgdbgbrk;
        return retst;
    }
    
    return retst;

}

bbool codegate::export_txt(hfile hfile_work, bbool only_codval /* = ffalse */)
{
    hgassert(hfile_work != hfile_error);

    if(hfile_work == hfile_error) {
        hgdbgbrk;
        return ffalse;
    }

    //
    bbool       retst = ffalse;

    //
    int         workcnt;
	p_codelink  p_worker;
    hgstr32     prtmsg32;

    //----------
    //  
    //----------
    workcnt = 0;
    p_worker = this->p_head;

    while(p_worker != nnull) {
        //
        workcnt++;

        if(hgfilewrite(hfile_work, &p_worker->value.code.ba_num, 
            (int)hgstrlen((p_str)p_worker->value.code.ba_num)) != 
            (int)hgstrlen((p_str)p_worker->value.code.ba_num)) {
            hgdbgbrk;
            return ffalse;
        }
        if(only_codval == ttrue) {
            // ڵ尪 ϴ  - ׳  ѱ.
            // ڵ带 Ȯ ϱ ؼ if-else ߴ.
        }
        else {
            // ڵ尪 ڵ ϴ 
            prtmsg32[0] = '(';
            if(hgfilewrite(hfile_work, prtmsg32, 1) != 1) {
                hgdbgbrk;
                return ffalse;
            }
            if(hgfilewrite(hfile_work, p_worker->value.code.p_name, 
                (int)hgstrlen(p_worker->value.code.p_name)) != 
				(int)hgstrlen(p_worker->value.code.p_name)) {
                hgdbgbrk;
                return ffalse;
            }
            prtmsg32[0] = ')';
            if(hgfilewrite(hfile_work, prtmsg32, 1) != 1) {
                hgdbgbrk;
                return ffalse;
            }
        }
        if(print_file(hfile_work, print_prbreadk_1)) {
            hgdbgbrk;
            return ffalse;
        }

        //
        p_worker = p_worker->p_next;
    }
    if(workcnt != this->m_codehead.linknum) {
        hgdbgbrk;
        return ffalse;
    }

    //
    retst = ttrue;

    return retst;
}

long codegate::count_firstitem()
{
    // 켱ָ ׸ Ѵ.
    long        itemnum = 0;

    //
    int         workcnt;
	p_codelink  p_worker;

    //----------
    //  
    //----------
    workcnt = 0;
    p_worker = this->p_head;

    while(p_worker != nnull) {
        //
        workcnt++;
        
        if(is_codelink_firstitem(p_worker) == ttrue) {
            itemnum++;
        }


        //
        p_worker = p_worker->p_next;
    }
    if(workcnt != this->m_codehead.linknum) {
        hgdbgbrk;
        return itemnum;
    }

    return itemnum;
}

