#ifndef _CODEINFO_DEFN_
#define _CODEINFO_DEFN_

#include "stockdef.h"

class codegate;

// Ϻ 
typedef struct strucodepair codepair, *p_codepair;
typedef p_codepair *pp_codepair;

typedef struct strucodeinfo_fix codefxin, *p_codefxin;
typedef p_codefxin *pp_codefxin;

typedef struct strucodeinfo codeinfo, *p_codeinfo;
typedef p_codeinfo *pp_codeinfo;

typedef struct strucodelink codelink, *p_codelink;
typedef p_codelink *pp_codelink;

typedef struct struCodeGateHead codehead, *p_codehead;
typedef p_codehead *pp_codehead;

typedef class codegate *p_codegate;
typedef p_codegate *pp_codegate;

//----------------
// ü Ǻκ
//----------------
struct strucodepair {
	hgstr16 ba_num; //  code
	p_str   p_name;
};

struct strucodeinfo_fix {
	// ڵ 
	hgstr16 ba_fullcode;    // full-code
	long	stk_code;       // Ǿڵ
    bbyte   market; // Ҽӱ(ŷ, ڽ, 3)
    bbyte   gamli;  // 
    bbyte   scale;  // ںݱԸ
	bbyte   cashtime;   // 
    long    groupcode;  // ׷ڵ
    bbyte   kospiflag;  // ڽǱ
    bbyte   admin;      // 
    bbyte   state;      // ֽĻ
    bbyte   packing1;   // 4-byte packing area
};

struct strucodeinfo {
    codepair    code;   // ڵ 
    codefxin    fixvalue;   //  
};

struct strucodelink {
	codeinfo    value;
    // bin-link
	p_codelink  p_par;
	p_codelink  p_left;
	p_codelink  p_right;
    // double-ling
	p_codelink  p_prev;
	p_codelink  p_next;
};

struct struCodeGateHead {
	// checksum
	hgstr64		checksum_strn;	//  +б⿡ ȿ  ˻ ڿ
    long        checksum_num;   //  +б⿡ ȿ  ˻ 
    // ڵƮ/(׸)
    hgstr64     ba_gatename;
	// ũ
    long        sortkey;// Ű
    //
	bbool       exc_3market;    // 3  
	long        sonum;  // ũ ߿ ŷ 
	long        daknum; // ũ ߿ ڽ 
	long        num3;   // ũ ߿ 3 
	long        extraup_num;// ̻޵ 
	long        admin_num;  //  
	long        stop_num;    // ŷ 
	long        lscale_num;  //  
	long        mscale_num;  //  
	long        sscale_num;  //  
	//
	long		linknum;
	//  ġ
	long		arcbeg;	// Ÿ   ġ
	long		arcend;
	// ࿵: 1024 - (4 * 14)
	BYTE		reserved[hgsize256];
};


//
class codegate
{
private:
	// 
	codehead	m_codehead;
    //
	p_codelink  p_top;
	p_codelink  p_head;
	p_codelink  p_tail;

public:
    codegate(p_codegate p_codegate_b = nnull, long sortkey_b = sortkey_invalid);
    ~codegate();
	//
    bbool init();
	void  init_link();
    bbool reset();
    bbool append(p_codelink p_new);
    bbool append(p_str p_codeval, p_str p_codename, p_codefxin p_fixvalue);
    bbool unlink(p_codelink p_unlik);
    bbool del(p_codelink p_del);
    long get_sortkey();
    void set_sortkey(long sortkey);
    long get_exc_3market();
    void set_exc_3market(bbool exc_3market);
    p_str get_groupname();
    bbool set_groupname(p_str p_groupname);
    long get_linknum();
    long get_linknum_so();
    long get_linknum_dak();
    long get_linknum_3();
    p_codelink get_top();
    p_codelink get_head();
    p_codelink get_tail();
    long find_recorder(p_codelink p_cur);
    p_codelink find_codeval(p_str p_codeval);
    p_codelink find_codename(p_str p_codename);
    p_codelink drag_entrylink(hgpos LocPos);
    p_str make_codeval_string(hgpos locbeg, long makenum, p_long p_makenum);
    bbool del_doublecode();
    bbool del_firstitem();  // 켱ִ ش.

    //
    bool centering_link();
    bool unlink_binlink();
    p_codelink binize_link(p_codelink lpHead, p_codelink lpTail, hgnum RecNum);
    p_codelink get_midlink(p_codelink lpHead, p_codelink lpTail, 
									 hgnum RecNum, LPHGNUM lpMidWordPos);
    bbool write(p_str p_file);
    bbool write(hfile hfile_work);
    bbool read(p_str p_file, long sortkey_b = sortkey_invalid, bbool exc_3market = ttrue);
    bbool read(hfile hfile_work, long sortkey_b = sortkey_invalid, bbool exc_3market = ttrue);
    hgnum exc_3market();
    
    bbool export_txt(p_str p_file, bbool only_codval = ffalse);
    bbool export_txt(hfile hfile_work, bbool only_codval = ffalse);
    long count_firstitem();
};

//
bbool init_codepair(p_codepair p_code);
bbool reset_codepair(p_codepair p_code);
bbool copy_codepair(p_codepair p_code_src, p_codepair p_code_dst);
bbool copy_codepair_data(p_codepair p_code_n, p_str p_codevalue, p_str p_codename);

//
bbool init_codefxin(p_codefxin p_info);

//
bbool comp_codeinfo(p_codeinfo p_info_b, p_codeinfo p_info_n, long sortkey, p_int p_retcomp);
bbool init_codeinfo(p_codeinfo p_info);

//
p_codelink  create_codelink(void);
bbool init_codelink(p_codelink p_infolink);
bbool init_codelink_link(p_codelink p_infolink);
bbool init_codelink_bin(p_codelink p_infolink);
bbool init_codelink_double(p_codelink p_infolink);
bbool free_codelink(pp_codelink pp_infolink);
bbool is_codelink_3market(p_codelink p_infolink);
bbool is_codelink_firstitem(p_codelink p_infolink);

//
bbool init_codehead(p_codehead p_codehead_n);
bbool reset_codehead(p_codehead p_codehead_n);

#endif  //- _CODEINFO_DEFN_

