#include "nowinfo.h"

//--------
// nowgate
//--------
bbool nowgate::write(p_str p_file, bbool textfile_f /* = ffalse */, bbool codelist_f /* = ffalse */)
{
    // codelist_f  textfile_f  ۵   ش.
    hgassert(p_file != nnull);

    if(p_file == nnull) {
        return ffalse;
    }

    bbool   retst = ffalse;
    hfile   hfile_work;

    hfile_work = HGFileCreate(p_file, FILE_CREATE_MODE);
    if(hfile_work == hfile_error) {
        hgdbgbrk;
        return ffalse;
    }

    if(textfile_f == ttrue) {
        retst = this->write_txt(hfile_work, codelist_f);
    }
    else {
        retst = this->write(hfile_work);
    }
    hgfileclose(hfile_work);
    if(retst == ffalse) {
        hgdbgbrk;
        return retst;
    }
    
    return retst;

}

bbool nowgate::write(hfile hfile_work)
{
    hgassert(hfile_work != hfile_error);

    if(hfile_work == hfile_error) {
        hgdbgbrk;
        return ffalse;
    }

    bbool   retst = ffalse;
    long    arcbeg_save;

    //------------
    //  
    //------------
    //    ġ صд.
    // nowgate ۰ ܺο   
    //   nowgate ġ ˾ƾ Ѵ.
    arcbeg_save = HGFP_CUR(hfile_work);

    if(hgfilewrite(hfile_work, &this->m_nowhead, 
        sizeof(this->m_nowhead)) != sizeof(this->m_nowhead)) {
        hgdbgbrk;
        return ffalse;
    }
    if(hgfilewrite(hfile_work, &this->m_nowanal, 
        sizeof(this->m_nowanal)) != sizeof(this->m_nowanal)) {
        hgdbgbrk;
        return ffalse;
    }
    if(hgfilewrite(hfile_work, &this->m_analopt, 
        sizeof(this->m_analopt)) != sizeof(this->m_analopt)) {
        hgdbgbrk;
        return ffalse;
    }

    //
    int         workcnt;
	p_nowlink  p_worker;

    //----------
    //  
    //----------
    workcnt = 0;
    p_worker = this->p_head;
    this->m_nowhead.arcbeg = HGFP_CUR(hfile_work);

    while(p_worker != nnull) {
        //
        workcnt++;

        if(hgfilewrite(hfile_work, &p_worker->value, 
            sizeof(p_worker->value)) != sizeof(p_worker->value)) {
            hgdbgbrk;
            return ffalse;
        }
        int     name_len = hgstrlen((LPCSTR)p_worker->value.code.p_name);
        if(hgfilewrite(hfile_work, &name_len, sizeof(name_len)) != sizeof(name_len)) {
            hgdbgbrk;
            return ffalse;
        }
        if(hgfilewrite(hfile_work, p_worker->value.code.p_name, name_len) != name_len) {
            hgdbgbrk;
            return ffalse;
        }
        bbool   movedata_f = ffalse;
        //------------------------
        // 2009.10.01. ӽ÷ 
        //------------------------
        //-if(p_worker->p_move != nnull) {
        //-    movedata_f = ttrue;
        //-}
        if(hgfilewrite(hfile_work, &movedata_f, sizeof(movedata_f)) != sizeof(movedata_f)) {
            hgdbgbrk;
            return ffalse;
        }
        //-if(movedata_f == ttrue) {
        //-    if(hgfilewrite(hfile_work, p_worker->p_move, sizeof(movepair)) != sizeof(movepair)) {
        //-        hgdbgbrk;
        //-        return ffalse;
        //-    }
        //-}
        //------------------------

        //
        p_worker = p_worker->p_next;
    }
    if(workcnt != this->m_nowhead.linknum) {
        hgdbgbrk;
        return ffalse;
    }

    //
    this->m_nowhead.arcend = HGFP_CUR(hfile_work);
    HGFP_SET(hfile_work, arcbeg_save);

   
    if(hgfilewrite(hfile_work, &this->m_nowhead, 
        sizeof(this->m_nowhead)) != sizeof(this->m_nowhead)) {
        hgdbgbrk;
        return ffalse;
    }

    //
    retst = ttrue;

    return retst;
}

bbool nowgate::write_txt(hfile hfile_work, bbool codelist_f /* = ffalse */)
{
    hgassert(hfile_work != hfile_error);

    if(hfile_work == hfile_error) {
        hgdbgbrk;
        return ffalse;
    }

    bbool   retst = ffalse;
    long    arcbeg_save;

    //------------
    //  
    //------------
    //    ġ صд.
    // nowgate ۰ ܺο   
    //   nowgate ġ ˾ƾ Ѵ.
    arcbeg_save = HGFP_CUR(hfile_work);

    //-if(hgfilewrite(hfile_work, &this->m_nowhead, 
    //-    sizeof(this->m_nowhead)) != sizeof(this->m_nowhead)) {
    //-    hgdbgbrk;
    //-    return ffalse;
    //-}
    //-if(hgfilewrite(hfile_work, &this->m_nowanal, 
    //-    sizeof(this->m_nowanal)) != sizeof(this->m_nowanal)) {
    //-    hgdbgbrk;
    //-    return ffalse;
    //-}
    //-if(hgfilewrite(hfile_work, &this->m_analopt, 
    //-    sizeof(this->m_analopt)) != sizeof(this->m_analopt)) {
    //-    hgdbgbrk;
    //-    return ffalse;
    //-}

    //
    int         workcnt;
	p_nowlink  p_worker;

    //----------
    //  
    //----------
    workcnt = 0;
    p_worker = this->p_head;
    //-this->m_nowhead.arcbeg = HGFP_CUR(hfile_work);

    while(p_worker != nnull) {
        //
        workcnt++;

        if(codelist_f == ffalse) {
            //   ʴ´.
            // 2007.10.01. 
            //  ڵ ϸ ini   ϱ ؼ ӽ÷ ڵ ߴ.
            // ߿ ϰ Ѵ.
            hgdbgbrk;
            return ffalse;
        
            //-if(hgfilewrite(hfile_work, &p_worker->value, 
            //-    sizeof(p_worker->value)) != sizeof(p_worker->value)) {
            //-    hgdbgbrk;
            //-    return ffalse;
            //-}
            //-int     name_len = hgstrlen((LPCSTR)p_worker->value.code.p_name);
            //-if(hgfilewrite(hfile_work, &name_len, sizeof(name_len)) != sizeof(name_len)) {
            //-    hgdbgbrk;
            //-    return ffalse;
            //-}
            //-if(hgfilewrite(hfile_work, p_worker->value.code.p_name, name_len) != name_len) {
            //-    hgdbgbrk;
            //-    return ffalse;
            //-}
            //-bbool   movedata_f = ffalse;
            //-if(p_worker->p_move != nnull) {
            //-    movedata_f = ttrue;
            //-}
            //-if(hgfilewrite(hfile_work, &movedata_f, sizeof(movedata_f)) != sizeof(movedata_f)) {
            //-    hgdbgbrk;
            //-    return ffalse;
            //-}
            //-if(movedata_f == ttrue) {
            //-    if(hgfilewrite(hfile_work, p_worker->p_move, sizeof(movepair)) != sizeof(movepair)) {
            //-        hgdbgbrk;
            //-        return ffalse;
            //-    }
            //-}
        }
        else {
            //        
            sprintf((p_str)prtmsg512, 
                "%s(%s)\r\n",
                p_worker->value.code.ba_num, p_worker->value.code.p_name);
            if(print_file(hfile_work, (p_str)prtmsg512)) {
                hgdbgbrk;
                return ffalse;
            }
        }

        //
        p_worker = p_worker->p_next;
    }
    if(workcnt != this->m_nowhead.linknum) {
        hgdbgbrk;
        return ffalse;
    }

    //
    //-this->m_nowhead.arcend = HGFP_CUR(hfile_work);
    //-HGFP_SET(hfile_work, arcbeg_save);

    //-if(hgfilewrite(hfile_work, &this->m_nowhead, 
    //-     sizeof(this->m_nowhead)) != sizeof(this->m_nowhead)) {
    //-     hgdbgbrk;
    //-     return ffalse;
    //-}

    //
    retst = ttrue;

    return retst;
}

bbool nowgate::read(p_str p_file, long sortkey_b /* = sortkey_invalid */)
{
    hgassert(p_file != nnull);

    if(p_file == nnull) {
        return ffalse;
    }

    //
    this->reset();
    
    //
    bbool   retst = ffalse;
    hfile   hfile_work;

    hfile_work = HGFileOpen(p_file, READ);
    if(hfile_work == hfile_error) {
        hgdbgbrk;
        return ffalse;
    }

    retst = this->read(hfile_work, sortkey_b);
    hgfileclose(hfile_work);
    
    if(retst == ffalse) {
        hgdbgbrk;
        return ffalse;
    }

    //
    retst = ttrue;

    return retst;

}

bbool nowgate::read(hfile hfile_work, long sortkey_b /* = sortkey_invalid */)
{
    hgassert(hfile_work != hfile_error);

    if(hfile_work == hfile_error) {
        return ffalse;
    }

    //
    this->reset();

    if(sortkey_b != sortkey_invalid) {
        this->set_sortkey(sortkey_b);
    }

    //
    bbool   retst = ffalse;

    //------------
    //  б
    //------------
    nowhead     nowhead_r;
    nowanal     nowanal_r;

    if(hgfileread(hfile_work, &nowhead_r, 
        sizeof(nowhead_r)) != sizeof(nowhead_r)) {
        hgdbgbrk;
        return ffalse;
    }

    //  ´ Ȯ - checksum ˻
    if(hgstrncmp((p_str)nowhead_r.checksum_strn, checksum_basic, hgstrlen(checksum_basic)) != 0) {
        hgdbgbrk;
        return ffalse;
    }
    if(nowhead_r.checksum_num != checksum_id_now) {    
        //  +б⿡ ȿ  ˻ 
        hgdbgbrk;
        return ffalse;
    }
    if(hgfileread(hfile_work, &nowanal_r, 
        sizeof(nowanal_r)) != sizeof(nowanal_r)) {
        hgdbgbrk;
        return ffalse;
    }

    //---------------------------------------
    //    ߿  Ѱ ϴ ͵ ִ.
    // - ߿ Ȯε  ϴ  Ѵ.
    //---------------------------------------
    hgstrcpy((p_str)this->m_nowhead.ba_gatename, (p_str)nowhead_r.ba_gatename);
    
    // ð+ð
    this->m_nowhead.runday = nowhead_r.runday;    //  ȹ ؼ Ų ¥
    this->m_nowhead.dataday = nowhead_r.dataday;   //  ȹ ¥(runday ʴ.)
    this->m_nowhead.datatime = nowhead_r.datatime;  //  ȹ ð(0=> 00:00:00, (-1) ȿ )
    //---------------------------------------
    //---------------------------------------

    //-----------------------------------
    // 06.07.04.
    // ؼ м  ׸ þ ִ.
    // ׷   ͸   
    //  ϴ 찡 Ƿ
    // nowhead.arcbeg  ̿Ͽ   д ġ
    // ش.
    // ߿  Ǹ  κ  ȴ.
    // Ͻ   ̹Ƿ ݵ
    //  κ  Ѵ.
    //-----------------------------------
    // ӽ÷  ͸ ̵Ų.
    // nowanal ü  Ǿ.
    // ׽Ʈ  ӽ 
    //-----------------------------------
    HGFP_SET(hfile_work, nowhead_r.arcbeg);

    //
    int         workcnt;

    //
    workcnt = 0;

    while(workcnt < nowhead_r.linknum) {

        //-// ӽ÷ 10 д´.
        //-if(workcnt >= 10) {
        //-    hgmsgbox("ӽ÷ 10 нϴ. ߿  ľ մϴ.", "debug", MB_OK);
        //-    break;
        //-}

        //
        nowinfo     nowinfo_r;
        hgstr256    codename;

        if(hgfileread(hfile_work, &nowinfo_r, 
            sizeof(nowinfo_r)) != sizeof(nowinfo_r)) {
            hgdbgbrk;
            return ffalse;
        }

        int     name_len;
        if(hgfileread(hfile_work, &name_len, sizeof(name_len)) != sizeof(name_len)) {
            hgdbgbrk;
            return ffalse;
        }
        if(hgfileread(hfile_work, (LPSTR)codename, name_len) != name_len) {
            hgdbgbrk;
            return ffalse;
        }
        codename[name_len] = 0x00;

        bbool       movedata_f = ffalse;
        //------------------------
        // 2009.10.01. ӽ÷ 
        //------------------------
        if(hgfileread(hfile_work, &movedata_f, sizeof(movedata_f)) != sizeof(movedata_f)) {
            hgdbgbrk;
            return ffalse;
        }
        //-if(movedata_f == ttrue) {
        //-    movepair    movepair_r;
        //-    if(hgfileread(hfile_work, &movepair_r, sizeof(movepair_r)) != sizeof(movepair_r)) {
        //-        hgdbgbrk;
        //-        return ffalse;
        //-    }
        //-}
        //------------------------

        //
        p_nowlink   p_now_apn = this->append((p_str)nowinfo_r.code.ba_num, 
                                    (LPSTR)codename, &nowinfo_r.fixvalue);
        if(p_now_apn == ffalse) {
            hgdbgbrk;
            return ffalse;
        }
        if(movedata_f == ttrue) {
            //------------------------
            // 2009.10.01. ӽ÷ 
            //------------------------
            //-p_now_apn->p_move = dup_movepair(&movepair_r);
            //-if(p_now_apn->p_move == nnull) {
            //-    hgdbgbrk;
            //-    return ffalse;
            //-}
            //------------------------
            hgdbgbrk;
            return ffalse;
        }

        //
        workcnt++;
    }
    if(workcnt != this->m_nowhead.linknum) {
        hgdbgbrk;
        return ffalse;
    }

    //
    retst = ttrue;

    //  ũ ȭŲ.
    // - 뷮 ݺ Ž ӵ  ش.
    this->centering_link();

    return retst;

}

p_codegate nowgate::make_codegate_sortver()
{
    if(this->get_linknum() <= 0) {    // ۿ   
        //-hgdbgbrk;
        return nnull;
    }

    p_codegate  p_codegate_sort;

    p_codegate_sort = new codegate(nnull, sortkey_codeval);

    // ۾
    int         loopcnt = 0;
    p_nowlink   p_link = this->get_head();

    while(p_link != nnull) {
        loopcnt++;

        if(p_codegate_sort->append((p_str)p_link->value.code.ba_num, 
            p_link->value.code.p_name, 
            &p_link->value.fixvalue.assist_code) == ffalse) {
            hgdbgbrk;
            delete p_codegate_sort;
            return nnull;
        }

        //
        p_link = p_link->p_next;
    }
    if(loopcnt != this->get_linknum()) {
        hgdbgbrk;
        delete p_codegate_sort;
        return nnull;
    }

    //  ؽƮ import ¶ nowgate ߺ ڵ尪   ִ.
    //  ؼ ߺ ڵ尪  ش.
    if(p_codegate_sort->del_doublecode() == ffalse) {
        hgdbgbrk;
        delete p_codegate_sort;
        return nnull;
    }

    return p_codegate_sort;
}

