#include "nowinfo.h"
#include <math.h>

//--------------
//--------------
bbool comp_nowinfo(p_nowinfo p_info_b, p_nowinfo p_info_n, long sortkey, p_int p_retcomp)
{
    hgassert((p_info_b != nnull) && (p_info_n != nnull) && (p_retcomp != nnull));

	if((p_info_b == nnull) || (p_info_n == nnull) || (p_retcomp == nnull)) {
        hgdbgbrk;
		return ffalse;
	}

    //
    float   retfloat, mod_rate_c, mod_rate_b;
    long    gabprice_c, gabprice_b;

    *p_retcomp = 0;

    switch(sortkey) {
    case sortkey_codeval:   // ڵ
        // ̸  ͺ óѴ.
        // ׷ ⼭  ġ ٲ.
        *p_retcomp = hgstrcmp((p_str)p_info_n->code.ba_num, (p_str)p_info_b->code.ba_num);
        break;
    case sortkey_codename:  // ̸
        // ̸  ͺ óѴ.
        // ׷ ⼭  ġ ٲ.
        *p_retcomp = hgstrcmp(p_info_n->code.p_name, p_info_b->code.p_name);
        break;
    case sortkey_amount_high:   // ŷ ūͺ
        if(p_info_b->fixvalue.pri.amount > p_info_n->fixvalue.pri.amount) {
            *p_retcomp = 1;
        }
        else if(p_info_b->fixvalue.pri.amount < p_info_n->fixvalue.pri.amount) {
            *p_retcomp = (-1);
        }
        else {
            *p_retcomp = 0;
        }
        break;
    case sortkey_amountrate_high:   // ŷ ūͺ
        *p_retcomp = p_info_b->fixvalue.amount_rate - p_info_n->fixvalue.amount_rate;
        break;
    case sortkey_amountrotate_high: //  ֽĿ  ŷ ȸ
        // float   ȯش.
        retfloat = p_info_b->fixvalue.amount_rotate - p_info_n->fixvalue.amount_rotate;
        if(retfloat > (float)0) {
            *p_retcomp = 1;
        }
        else if(retfloat < (float)0) {
            *p_retcomp = (-1);
        }
        else {
            *p_retcomp = 0;
        }
        break;
    case sortkey_money_high:    // ŷ ūͺ
        //----------------------------------------------------------------------------
        // ŷ ϴ.
        // ŷҴ  ؾ ϰ, ڽ õ ؼ ߰ ؾ Ѵ.
        // append()Լ ŷҴ ڵ õ سҴ.
        // ׷ ⼭ ׳ 길 ϸ ȴ.
        //----------------------------------------------------------------------------
        *p_retcomp = p_info_b->fixvalue.money - p_info_n->fixvalue.money;
        break;
    case sortkey_rate_high: //  ūͺ
        // float   ȯش.
        retfloat = p_info_b->fixvalue.pri.rate - p_info_n->fixvalue.pri.rate;
        if(retfloat > (float)0) {
            *p_retcomp = 1;
        }
        else if(retfloat < (float)0) {
            *p_retcomp = (-1);
        }
        else {
            *p_retcomp = 0;
        }
        break;
    case sortkey_rate_low: //   ͺ
        // float   ȯش.
        retfloat = p_info_b->fixvalue.pri.rate - p_info_n->fixvalue.pri.rate;
        if(retfloat < (float)0) {
            *p_retcomp = 1;
        }
        else if(retfloat > (float)0) {
            *p_retcomp = (-1);
        }
        else {
            *p_retcomp = 0;
        }
        break;
    case sortkey_presee_rate_high: // üᰡ  ūͺ
        // float   ȯش.
        gabprice_b = p_info_b->fixvalue.preconnect_price - p_info_b->fixvalue.yesday_endval;
        mod_rate_b = calc_rate(p_info_b->fixvalue.yesday_endval, gabprice_b);

        gabprice_c = p_info_n->fixvalue.preconnect_price - p_info_n->fixvalue.yesday_endval;
        mod_rate_c = calc_rate(p_info_n->fixvalue.yesday_endval, gabprice_c);

        retfloat = mod_rate_b - mod_rate_c;
        if(retfloat > (float)0) {
            *p_retcomp = 1;
        }
        else if(retfloat < (float)0) {
            *p_retcomp = (-1);
        }
        else {
            *p_retcomp = 0;
        }
        break;
    case sortkey_lastatach: //  ڿ ̱(ũ   )
        *p_retcomp = (1);
        break;
    case sortkey_price_high:    // ֽİ ū ͺ
        if(p_info_b->fixvalue.pri.endval > p_info_n->fixvalue.pri.endval) {
            *p_retcomp = 1;
        }
        else if(p_info_b->fixvalue.pri.endval < p_info_n->fixvalue.pri.endval) {
            *p_retcomp = (-1);
        }
        else {
            *p_retcomp = 0;
        }
        break;
    case sortkey_price_low: // ֽİ  ͺ
        if(p_info_b->fixvalue.pri.endval < p_info_n->fixvalue.pri.endval) {
            *p_retcomp = 1;
        }
        else if(p_info_b->fixvalue.pri.endval > p_info_n->fixvalue.pri.endval) {
            *p_retcomp = (-1);
        }
        else {
            *p_retcomp = 0;
        }
        break;
    case sortkey_conpower_high: // üᰭ ū ͺ
        if(p_info_b->fixvalue.connect_power > p_info_n->fixvalue.connect_power) {
            *p_retcomp = 1;
        }
        else if(p_info_b->fixvalue.connect_power < p_info_n->fixvalue.connect_power) {
            *p_retcomp = (-1);
        }
        else {
            *p_retcomp = 0;
        }
        break;
    case sortkey_conpower_low:  // üᰭ  ͺ
        if(p_info_b->fixvalue.connect_power < p_info_n->fixvalue.connect_power) {
            *p_retcomp = 1;
        }
        else if(p_info_b->fixvalue.connect_power > p_info_n->fixvalue.connect_power) {
            *p_retcomp = (-1);
        }
        else {
            *p_retcomp = 0;
        }
        break;
    default:
        hgdbgbrk;
		return ffalse;
    }

    if(*p_retcomp == 0) {
        //----------------------------------------------------------------------
        // 2006.08.01.
        // ߰ 񱳰 ش.
        //    unlink[del]Ҷ  ũ   ȴ.
        // unlink[del]Ҷ   ߰ߵǸ Ź centering ־ Ѵ.
        // ȿ̹Ƿ ߺ ߻ ʵ ģ.
        //----------------------------------------------------------------------
        *p_retcomp = hgstrcmp((p_str)p_info_n->code.ba_num, (p_str)p_info_b->code.ba_num);
    }

	return ttrue;
}

float calc_nowinfo_rate(p_nowinfo p_info, bbool begval /* = ffalse */)
{
    float   retval = 0;

    hgassert(p_info != nnull);

    if(p_info == nnull) {
        return retval;
    }

    retval = calc_nowfxin_rate(&p_info->fixvalue, begval);

    return retval;
}

float calc_nowinfo_lowdaebi_rate(p_nowinfo p_info, bbool lowbal /* = ffalse */)
{
    float   retval = 0;

    hgassert(p_info != nnull);

    if(p_info == nnull) {
        return retval;
    }

    retval = calc_nowfxin_lowdaebi_rate(&p_info->fixvalue, lowbal);

    return retval;
}

long calc_nowinfo_amountrate(p_nowinfo p_info)
{
    long    retval = 0;

    hgassert(p_info != nnull);

    if(p_info == nnull) {
        return retval;
    }

    retval = calc_nowfxin_amountrate(&p_info->fixvalue);

    return retval;
}

float calc_nowinfo_amountrotation(p_nowinfo p_info)
{
    float   retval = 0;

    hgassert(p_info != nnull);

    if(p_info == nnull) {
        return retval;
    }

    //- ׿ ڵ
    //-if(hgstrcmp((p_str)p_info->code.ba_num, "A002365") == 0) {
    //-    retval = 0;
    //-}
    retval = calc_nowfxin_amountrotation(&p_info->fixvalue);

    return retval;
}

bbool init_nowinfo(p_nowinfo p_info)
{
	if(p_info == nnull) {
		return ffalse;
	}

    init_codepair(&p_info->code);
    init_nowfxin(&p_info->fixvalue);

	return ttrue;
}

bbool is_nowinfo_updown_up(p_nowinfo p_info)
{   
    //ΰ
	if(p_info == nnull) {
		return ffalse;
	}

    return is_nowfxin_updown_up(&p_info->fixvalue);
}

bbool is_nowinfo_updown_down(p_nowinfo p_info)
{   
    //϶ΰ
	if(p_info == nnull) {
		return ffalse;
	}

    return is_nowfxin_updown_down(&p_info->fixvalue);
}

bbool is_nowinfo_updown_non(p_nowinfo p_info)
{   
    //ΰ
	if(p_info == nnull) {
		return ffalse;
	}

    return is_nowfxin_updown_non(&p_info->fixvalue);
}

bbool is_nowinfo_updown_upmax(p_nowinfo p_info)
{   
    //ΰ
	if(p_info == nnull) {
		return ffalse;
	}

    return is_nowfxin_updown_upmax(&p_info->fixvalue);
}

bbool is_nowinfo_updown_downmax(p_nowinfo p_info)
{   
    //ΰ
	if(p_info == nnull) {
		return ffalse;
	}

    return is_nowfxin_updown_downmax(&p_info->fixvalue);
}

bbool is_nowinfo_updown_upmaxout(p_nowinfo p_info)
{   
    // Ż
	if(p_info == nnull) {
		return ffalse;
	}

    return is_nowfxin_updown_upmaxout(&p_info->fixvalue);
}

bbool is_nowinfo_updown_downmaxout(p_nowinfo p_info)
{   
    // Ż
	if(p_info == nnull) {
		return ffalse;
	}

    //-----------------------------------------------
    // ׸ ؼ Ƴ ڵ
    //-----------------------------------------------
    //-if(hgstrcmp(p_info->codename, "") == 0) {
    //-    int     dummy;
    //-    dummy = 1;
    //-}
    //-----------------------------------------------

    return is_nowfxin_updown_downmaxout(&p_info->fixvalue);
}

bbool is_nowinfo_uprate_higharea(p_nowinfo p_info)
{   
    //
	if(p_info == nnull) {
		return ffalse;
	}

    return is_nowfxin_uprate_higharea(&p_info->fixvalue);
}

bbool is_nowinfo_uprate_upmaxarea(p_nowinfo p_info)
{   
    // Ѱ α
	if(p_info == nnull) {
		return ffalse;
	}

    return is_nowfxin_uprate_upmaxarea(&p_info->fixvalue);
}

bbool is_nowinfo_uprate_lowarea(p_nowinfo p_info)
{   
    //
	if(p_info == nnull) {
		return ffalse;
	}

    return is_nowfxin_uprate_lowarea(&p_info->fixvalue);
}

bbool is_nowinfo_uprate_downmaxarea(p_nowinfo p_info)
{   
    // Ѱ α
	if(p_info == nnull) {
		return ffalse;
	}

    return is_nowfxin_uprate_downmaxarea(&p_info->fixvalue);
}

//-----------------------------
// nowlink
//-----------------------------
p_nowlink create_nowlink_codeinfo(p_codeinfo p_codeinfo_b)
{
    //-----------------------------------------------------
    //  Լ codeinfoκ  ̶
    // nowinfo ִ   Ϻθ  ش.
    // {codename, value.fixvalue.assistcode}
    //   Լ  nowlink ׸ 
    //     Ư  ؼ Ѵ.
    // 
    //  ƴ Ϻ  ϸ  ü ȸ 쿡
    //   ٿε ʰ,
    // ̹  ٿε  ϸ鼭 ʿ  ޲۴.
    //-----------------------------------------------------
    hgassert(p_codeinfo_b != nnull);

    if(p_codeinfo_b == nnull) {
        return nnull;
    }

    //
	p_nowlink	p_infolink_n = create_nowlink();;
	if(p_infolink_n == nnull) {
		hgdbgbrk;
		return nnull;
	}

    //
    hgstrncpy((p_str)p_infolink_n->value.code.ba_num, 
        (p_str)p_codeinfo_b->code.ba_num,
        sizeof(p_infolink_n->value.code.ba_num));

    p_infolink_n->value.code.p_name = hgstrdup(p_codeinfo_b->code.p_name);
    if(p_infolink_n->value.code.p_name == nnull) {
        hgdbgbrk;
		if(free_nowlink(&p_infolink_n) == ffalse) {
			hgdbgbrk;
		}
        return nnull;
    }

    //
    p_infolink_n->value.fixvalue.assist_code = p_codeinfo_b->fixvalue;

	return p_infolink_n;
}

p_nowlink dup_nowlink(p_nowlink	p_infolink_b)
{
	p_nowlink	p_infolink_n;

	p_infolink_n = create_nowlink();
	if(p_infolink_n == nnull) {
		hgdbgbrk;
		return nnull;
	}

    //
    hgstrncpy((p_str)p_infolink_n->value.code.ba_num, 
        (p_str)p_infolink_b->value.code.ba_num,
        sizeof(p_infolink_n->value.code.ba_num));

    //
    p_infolink_n->value.code.p_name = hgstrdup(p_infolink_b->value.code.p_name);
    if(p_infolink_n->value.code.p_name == nnull) {
        hgdbgbrk;
		if(free_nowlink(&p_infolink_n) == ffalse) {
			hgdbgbrk;
		}
        return nnull;
    }

    //
    p_infolink_n->value.fixvalue = p_infolink_b->value.fixvalue;

    if(p_infolink_b->p_move != nnull) {
        //------------------------
        // 2009.10.01. ӽ÷ 
        //------------------------
        //-p_infolink_n->p_move = dup_movepair(p_infolink_b->p_move);
        //-if(p_infolink_n->p_move == nnull) {
        //-    hgdbgbrk;
		//-    if(free_nowlink(&p_infolink_n) == ffalse) {
		//-	    hgdbgbrk;
		//-    }
        //-    return nnull;
        //-}
        //------------------------
		hgdbgbrk;
        return nnull;
    }

    p_infolink_n->gab_time = p_infolink_b->gab_time;    //    ð
    p_infolink_n->gab_amount = p_infolink_b->gab_amount;  //    ŷ
    p_infolink_n->gab_rate = p_infolink_b->gab_rate;    //    
    p_infolink_n->gab_trademoney_avg = p_infolink_b->gab_trademoney_avg;//   ŷ ݾ(ݺ հ )

    return p_infolink_n;
}

p_nowlink create_nowlink(void)
{
	p_nowlink	p_infolink;

	p_infolink = (p_nowlink)hgalloc(sizeof(nowlink));
	if(p_infolink == nnull) {
		hgdbgbrk;
		return nnull;
	}

	if(init_nowlink(p_infolink) == ffalse) {
		hgdbgbrk;
		if(free_nowlink(&p_infolink) == ffalse) {
			hgdbgbrk;
		}
		return nnull;
	}

	return p_infolink;
}

bbool init_nowlink(p_nowlink p_infolink)
{
	if(p_infolink == nnull) {
		hgdbgbrk;
		return ffalse;
	}

	if(init_nowinfo(&p_infolink->value) == ffalse) {
		hgdbgbrk;
		return ffalse;
	}
    p_infolink->p_move = nnull;
    p_infolink->gab_time = 0;    //    ð
    p_infolink->gab_amount = 0;  //    ŷ
    p_infolink->gab_rate = 0;    //    
    p_infolink->gab_trademoney_avg = 0;//   ŷ ݾ(ݺ հ )

	if(init_nowlink_link(p_infolink) == ffalse) {
		hgdbgbrk;
		return ffalse;
	}

	return ttrue;
}


bbool init_nowlink_link(p_nowlink p_infolink)
{
	if(p_infolink == nnull) {
		hgdbgbrk;
		return ffalse;
	}

    // bin-link
    init_nowlink_bin(p_infolink);
    // double-ling
    init_nowlink_double(p_infolink);

	return ttrue;
}

bbool init_nowlink_bin(p_nowlink p_infolink)
{
	if(p_infolink == nnull) {
		hgdbgbrk;
		return ffalse;
	}

    // bin-link
	p_infolink->p_par = nnull;
	p_infolink->p_left = nnull;
	p_infolink->p_right = nnull;

	return ttrue;
}

bbool init_nowlink_double(p_nowlink p_infolink)
{
	if(p_infolink == nnull) {
		hgdbgbrk;
		return ffalse;
	}

    // double-ling
    p_infolink->p_prev = nnull;
	p_infolink->p_next = nnull;

	return ttrue;
}

bbool free_nowlink(pp_nowlink pp_infolink)
{
	if(pp_infolink == nnull) {
		hgdbgbrk;
		return ffalse;
	}

	p_nowlink	p_infolink;
	p_infolink = *pp_infolink;

    if(p_infolink->value.code.p_name != nnull) {
        hgfree(p_infolink->value.code.p_name);
        p_infolink->value.code.p_name = nnull;
    }

    if(p_infolink->p_move) {
        hgfree(p_infolink->p_move);
        p_infolink->p_move = nnull;
    }

	hgfree(p_infolink);
	p_infolink = nnull;

	*pp_infolink = nnull;

	return ttrue;
}

//--------------
// nowgate_head
//--------------
bbool init_nowhead(p_nowhead p_nowhead_n)
{
    hgassert(p_nowhead_n != nnull);

    if(p_nowhead_n == nnull) {
        return ffalse;
    }

	// checksum
	hginitstring((LPSTR)p_nowhead_n->checksum_strn, sizeof(p_nowhead_n->checksum_strn), 0x00);
	hgstrcpy((LPSTR)p_nowhead_n->checksum_strn, checksum_basic);
    p_nowhead_n->checksum_num = checksum_id_now;   //  +б⿡ ȿ  ˻ 

	hginitstring((LPSTR)p_nowhead_n->ba_gatename, sizeof(p_nowhead_n->ba_gatename), 0x00);

    // ũ
    p_nowhead_n->assistcode = ffalse; // codegate  Ȯ  
    p_nowhead_n->sortkey = sortkey_rate_high;// Ű- ʱⰪ д.
    // ð+ð
    p_nowhead_n->runday = 0;    //  ȹ ؼ Ų ¥
    p_nowhead_n->dataday = 0;   //  ȹ ¥(runday ʴ.)
    p_nowhead_n->datatime = (-1);  //  ȹ ð(0=> 00:00:00, (-1) ȿ )
    //
	p_nowhead_n->linknum = 0;

    //
    p_nowhead_n->avgmount20_filter = 0;    // 20 հŷ
    p_nowhead_n->pluscandle_many_filter = 0;//   

    //  ġ
	p_nowhead_n->arcbeg = hgpos_inv;	// Ϻ Ÿ   ġ
	p_nowhead_n->arcend = hgpos_inv;

    return ttrue;
}

bbool reset_nowhead(p_nowhead p_nowhead_n)
{
    hgassert(p_nowhead_n != nnull);

    if(p_nowhead_n == nnull) {
        hgdbgbrk;
        return ffalse;
    }

    if(init_nowhead(p_nowhead_n) == ffalse) {
        hgdbgbrk;
        return ffalse;
    }

    return ttrue;
}

bbool init_nowanal(p_nowanal p_nowanal_n)
{
    hgassert(p_nowanal_n != nnull);

    if(p_nowanal_n == nnull) {
        return ffalse;
    }

    // +϶
    p_nowanal_n->num_up = 0; // 
    p_nowanal_n->num_midup = 0;  // ߰(5%)
    p_nowanal_n->num_higharea = 0;   // (10%)
    p_nowanal_n->num_upmaxarea = 0;  // Ѱα
    p_nowanal_n->num_upmax = 0;  // Ѱ
    p_nowanal_n->num_upmax_series = 0;// ӻѰ
    p_nowanal_n->num_upmax_5day = 0; // 5ùѰ
    p_nowanal_n->num_upmax_20day = 0;// 20ùѰ(5ϳ ùѰ  ʴ´.)
    p_nowanal_n->num_upmax_pause = 0;// Ѱ
    p_nowanal_n->num_upmaxafter = 0; // Ѱ Ż
    p_nowanal_n->num_down = 0;   // ϶
    p_nowanal_n->num_middown = 0;    // ߰(-5%) ϶
    p_nowanal_n->num_lowarea = 0;    // (-10%) ϶
    p_nowanal_n->num_downmaxarea = 0;// Ѱα
    p_nowanal_n->num_downmax = 0;    // Ѱ
    p_nowanal_n->num_downmaxafter = 0;   // Ѱ - Ѱ Ż
    p_nowanal_n->num_stop = 0;   // ŷ
    // ĵ - +
    p_nowanal_n->num_pluscandle = 0; // 
    p_nowanal_n->num_gab_pluscandle = 0; // ϶ 
    p_nowanal_n->num_minuscandle = 0;// 
    p_nowanal_n->num_flatcandle = 0; // 
    p_nowanal_n->num_kangyakcandle = 0; //  
    p_nowanal_n->num_reverhammer = 0;   // ġ 
    p_nowanal_n->num_smallaen = 0;   // small-N (Ѱ)
    // ̵ռ
    p_nowanal_n->num_move5_up = 0;   // 5ϼ ⵹
    p_nowanal_n->num_move20_up = 0;  // 20ϼ ⵹
    p_nowanal_n->num_move60_up = 0;  // 60ϼ ⵹
    p_nowanal_n->num_move120_up = 0; // 120ϼ ⵹
    p_nowanal_n->num_move240_up = 0; // 240ϼ ⵹
    p_nowanal_n->num_move480_up = 0; // 480ϼ ⵹
    p_nowanal_n->num_move520_drilup = 0;    // 5+20 ÿ ϴ 
    p_nowanal_n->num_move5_down = 0;   // 5ϼ ⵹
    p_nowanal_n->num_move20_down = 0;  // 20ϼ ⵹
    p_nowanal_n->num_move60_down = 0;  // 60ϼ ⵹
    p_nowanal_n->num_move120_down = 0; // 120ϼ ⵹
    p_nowanal_n->num_move240_down = 0; // 240ϼ ⵹
    p_nowanal_n->num_move480_down = 0; // 480ϼ ⵹
    //-
    p_nowanal_n->num_move5_on = 0;    // 5ϼ  ִ 
    p_nowanal_n->num_move20_on = 0;   // 20ϼ  ִ 
    p_nowanal_n->num_move60_on = 0;   // 60ϼ  ִ 
    p_nowanal_n->num_move120_on = 0;  // 120ϼ  ִ 
    p_nowanal_n->num_move240_on = 0;  // 240ϼ  ִ 
    p_nowanal_n->num_move480_on = 0;  // 480ϼ  ִ 
    //-
    p_nowanal_n->num_move5_below = 0;    // 5ϼ Ʒִ 
    p_nowanal_n->num_move20_below = 0;   // 20ϼ Ʒִ 
    p_nowanal_n->num_move60_below = 0;   // 60ϼ Ʒִ 
    p_nowanal_n->num_move120_below = 0;  // 120ϼ Ʒִ 
    p_nowanal_n->num_move240_below = 0;  // 240ϼ Ʒִ 
    p_nowanal_n->num_move480_below = 0;  // 480ϼ Ʒִ 
    //-
    p_nowanal_n->num_move5_20_pluslayer = 0; // 5-20 迭 
    p_nowanal_n->num_move5_60_pluslayer = 0; // 5-20-60 迭 
    p_nowanal_n->num_move5_120_pluslayer = 0;// 5-20-60-120 迭 
    p_nowanal_n->num_move20_5_minuslayer = 0; // 5-20 迭 
    p_nowanal_n->num_move60_5_minuslayer = 0; // 5-20-60 迭 
    p_nowanal_n->num_move120_5_minuslayer = 0;// 5-20-60-120 迭 
    p_nowanal_n->num_move60_5_20_layer = 0;// 60-5-20 ܱ ʹ
    p_nowanal_n->num_move20_5_60_layer = 0;// 20-5-60 ܱ ʹ
    p_nowanal_n->num_move_noarea_5_20_layer = 0;// 5-20迭/20-5迭 ƴ  -  
    p_nowanal_n->num_move_join_5_20_layer = 0;   // 5-20

    //
    p_nowanal_n->num_precross_520 = 0;  // 5-20 迭(迭 )
    p_nowanal_n->num_postcross_520 = 0; // 5-20 迭(迭 ʱ);
    p_nowanal_n->num_pause_avg20 = 0;   // 20ϼ 
    p_nowanal_n->num_pause_avg5 = 0;    // 5ϼ 
    p_nowanal_n->num_pluscandle_many = 0;//   -    Լ  ޴´.
    p_nowanal_n->num_rocket_pause1 = 0;  // ޵  ù
    p_nowanal_n->num_connectpower_250 = 0;// üᰭ 250%̻ 
    //
    p_nowanal_n->run_opt_rate = ffalse;   //      

    return ttrue;
}

bbool reset_nowanal(p_nowanal p_nowanal_n)
{
    hgassert(p_nowanal_n != nnull);

    if(p_nowanal_n == nnull) {
        hgdbgbrk;
        return ffalse;
    }

    if(init_nowanal(p_nowanal_n) == ffalse) {
        hgdbgbrk;
        return ffalse;
    }

    return ttrue;
}

