#include "priceinfo.h"

//-------------------
//-------------------
bbool init_price(p_price p_info)
{
	if(p_info == nnull) {
		return ffalse;
	}

	p_info->time = 0;
	p_info->begval = 0;
	p_info->highval = 0;
	p_info->lowval = 0;
	p_info->endval = 0;
	p_info->yesday_daebi = 0;
	p_info->amount = 0;
	p_info->rate = 0.0;

	return ttrue;
}

long get_price_bodyval(p_price p_info)
{
    long    retval = 0;

    hgassert(p_info != nnull);

    if(p_info == nnull) {
        return retval;
    }
    
    retval = p_info->endval - p_info->begval;

    return retval;
}

float get_price_bodyrate(p_price p_info)
{
    float   retval = 0;

    hgassert(p_info != nnull);

    if(p_info == nnull) {
        return retval;
    }

    retval = calc_price_rate(p_info, ttrue);
    return retval;
}

long get_yesday_price(p_price p_info)
{
    long    retval = 0;

    hgassert(p_info != nnull);

    if(p_info == nnull) {
        return retval;
    }
    
    retval = p_info->endval - p_info->yesday_daebi;

    return retval;
}

float calc_price_rate(p_price p_info, bbool begval /* = ffalse */)
{
    float   retval = 0;

    hgassert(p_info != nnull);

    if(p_info == nnull) {
        return retval;
    }

    ulong   yesday_endval = p_info->endval - p_info->yesday_daebi;

    if(begval == ttrue) {   //  ð 
        if(p_info->begval == 0) {
            //  ʰ   
            return retval;
        }
        // ð 簡   - '0'   .
        if(p_info->endval == p_info->begval) {
            return retval;
        }
        if(p_info->endval == 0) {
            //    쵵  ...=>ű ù...
            return retval;
        }
        if(yesday_endval == 0) {
            //    쵵  ...=>ű ù...
            return retval;
        }

        retval = calc_rate(yesday_endval, (p_info->endval - p_info->begval));
    }
    else {  //   
        // ձ Ȯ - '0'   .
        if(p_info->yesday_daebi == 0) {
            return retval;
        }
        if(yesday_endval == 0) {
            //    쵵  ...=>ű ù...
            return retval;
        }

        retval = calc_rate(yesday_endval, p_info->yesday_daebi);
    }

    return retval;
}

bbool is_price_pluscandle(p_price p_info)
{
    if(p_info == nnull) {
        return ffalse;
    }

    if((p_info->endval == 0) || (p_info->begval == 0)) {
        return ffalse;
    }
    if(p_info->endval > p_info->begval) {
        return ttrue;
    }
    else {
        return ffalse;
    }
}

bbool is_price_minuscandle(p_price p_info)
{
    if(p_info == nnull) {
        return ffalse;
    }

    if((p_info->endval == 0) || (p_info->begval == 0)) {
        return ffalse;
    }
    if(p_info->endval < p_info->begval) {
        return ttrue;
    }
    else {
        return ffalse;
    }
}

bbool is_price_flatcandle(p_price p_info)
{
    if(p_info == nnull) {
        return ffalse;
    }

    if((p_info->endval == 0) || (p_info->begval == 0)) {
        return ffalse;
    }
    if(p_info->endval == p_info->begval) {
        return ttrue;
    }
    else {
        return ffalse;
    }
}

bbool is_price_underscorecandle(p_price p_info)
{
    if(p_info == nnull) {
        return ffalse;
    }

    if((p_info->endval == 0) || (p_info->begval == 0)) {
        return ffalse;
    }
    if((p_info->endval == p_info->begval) && 
        (p_info->endval == p_info->lowval) &&
        (p_info->endval == p_info->highval)) {
         // ð+++   
        return ttrue;
    }
    else {
        return ffalse;
    }
}

float get_money_avg3(p_price p_info)
{
    // mfi ؼ   ϱ
    float   moneyflow = 0.00;

    // 
	if(p_info == nnull) {
        hgdbgbrk;
		return moneyflow;
	}

    //
    moneyflow = (float)(p_info->highval + p_info->endval + p_info->lowval);

    moneyflow = moneyflow / 3;

    return moneyflow;
}

float get_money_avg2(p_price p_info)
{
    // ׳ ð    ϱ
    float   moneyhalf = 0.00;

    // 
	if(p_info == nnull) {
        hgdbgbrk;
		return moneyhalf;
	}

    //
    moneyhalf = (float)(p_info->begval + p_info->endval);

    moneyhalf = moneyhalf / 2;

    return moneyhalf;
}

bbool is_price_updown_up(p_price p_info)
{   
    //ΰ
	if(p_info == nnull) {
		return ffalse;
	}

    //
    if(p_info->yesday_daebi <= 0) {
        return ffalse;
    }

	return ttrue;
}

bbool is_price_updown_down(p_price p_info)
{   
    //϶ΰ
	if(p_info == nnull) {
		return ffalse;
	}

    //
    if(p_info->yesday_daebi >= 0) {
        return ffalse;
    }

	return ttrue;
}

bbool is_price_updown_non(p_price p_info)
{   
    //ΰ
	if(p_info == nnull) {
		return ffalse;
	}

    //
    if(p_info->yesday_daebi != 0) {
        return ffalse;
    }

	return ttrue;
}

bbool is_price_updown_upmax(p_price p_info)
{   
    //ΰ
	if(p_info == nnull) {
		return ffalse;
	}

    //
    if((p_info->endval <= 0) || //    ִ.
        (p_info->yesday_daebi <= 0)) {
        return ffalse;
    }

    int yesday_endval = get_yesday_price(p_info);
    if(yesday_endval == 0) {
        //    쵵  ...=>ű ù...
        return ffalse;
    }
    if(p_info->yesday_daebi != 
        count_limitmax_high(yesday_endval)) {
        return ffalse;
    }

	return ttrue;
}

bbool is_price_updown_downmax(p_price p_info)
{   
    //ΰ
	if(p_info == nnull) {
		return ffalse;
	}

    //
    if((p_info->endval <= 0) || //    ִ.
        (p_info->yesday_daebi >= 0)) {
        return ffalse;
    }
    int yesday_endval = get_yesday_price(p_info);
    if(yesday_endval == 0) {
        //    쵵  ...=>ű ù...
        return ffalse;
    }
    if(p_info->yesday_daebi != 
        count_limitmax_low(yesday_endval)) {
        return ffalse;
    }

	return ttrue;
}

bbool is_price_updown_upmaxout(p_price p_info)
{   
    // Ż
	if(p_info == nnull) {
		return ffalse;
	}

    //
    if((p_info->endval <= 0) || //    ִ.
        (p_info->highval <= 0)) { //    ִ.
        return ffalse;
    }

    int yesday_endval = get_yesday_price(p_info);
    if(yesday_endval == 0) {
        //    쵵  ...=>ű ù...
        return ffalse;
    }

    int     daebi_high;
    daebi_high = p_info->highval - yesday_endval;
    if(daebi_high != 
        count_limitmax_high(yesday_endval)) { //  Ѱ  Ȯ
        return ffalse;
    }
    if(p_info->endval == p_info->highval) {   // Ѱ   ȴ.
        return ffalse;
    }

	return ttrue;
}

bbool is_price_updown_downmaxout(p_price p_info)
{   
    // Ż
	if(p_info == nnull) {
		return ffalse;
	}

    //
    if((p_info->endval <= 0) || //    ִ.
        (p_info->lowval <= 0)) {  //    ִ.
        return ffalse;
    }
    int yesday_endval = get_yesday_price(p_info);
    if(yesday_endval == 0) {
        //    쵵  ...=>ű ù...
        return ffalse;
    }

    int     daebi_low;
    daebi_low = p_info->lowval - yesday_endval;
    if(daebi_low != 
        count_limitmax_low(yesday_endval)) { //  Ѱ  Ȯ
        return ffalse;
    }
    if(p_info->endval == p_info->lowval) {   // Ѱ   ȴ.
        return ffalse;
    }

	return ttrue;
}

bbool is_price_uprate_higharea(p_price p_info)
{   
    //
	if(p_info == nnull) {
		return ffalse;
	}

    //
    if(p_info->rate < uprate_higharea) {
        return ffalse;
    }

	return ttrue;
}

bbool is_price_uprate_upmaxarea(p_price p_info)
{   
    // Ѱ α
	if(p_info == nnull) {
		return ffalse;
	}

    //
    if(p_info->rate < uprate_upmaxarea) {
        return ffalse;
    }

	return ttrue;
}

bbool is_price_uprate_lowarea(p_price p_info)
{   
    //
	if(p_info == nnull) {
		return ffalse;
	}

    //
    if(p_info->rate > downrate_lowarea) {
        return ffalse;
    }

	return ttrue;
}

bbool is_price_uprate_downmaxarea(p_price p_info)
{   
    // Ѱ α
	if(p_info == nnull) {
		return ffalse;
	}

    //
    if(p_info->rate > downrate_downmaxarea) {
        return ffalse;
    }

	return ttrue;
}

//---------------
//---------------
bbool init_dayval(p_dayval p_info)
{
	if(p_info == nnull) {
		return ffalse;
	}

	p_info->day = 0;
	p_info->val = 0;

	return ttrue;
}

