#include "stockdef.h"
#include "math.h"

bbool is_firstitem(p_str p_codeval)
{
	if(p_codeval == nnull) {
		hgdbgbrk;
		return ffalse;
	}
    if(p_codeval[0] == 0x00) {
		hgdbgbrk;
        return ffalse;
    }

    switch(p_codeval[hgstrlen(p_codeval) - 1]) {
    case '5':
    case '6':
    case '7':
        return ttrue;
    }

	return ffalse;
}

long get_curtime_hourmin()
{
    HGTIME      CurTime;

    HGGetTime(&CurTime);

    long    curtime = CurTime.hour * 100;
    curtime += CurTime.min;
    return curtime;
}

long get_time_bungab(long pretime, long posttime)
{
    hgassert((pretime != 0) && (posttime != 0));

    if((pretime == 0) || (posttime == 0)) {
        return 0;
    }

    long    longday = 0;
    long    mod_pre, mod_post, div_pre, div_post;

    mod_pre = pretime % 100;
    mod_post = posttime % 100;
    div_pre = pretime / 100;
    div_post = posttime / 100; 

    if(pretime > posttime) {
        longday = mod_pre - mod_post;
        if(longday < 0) {
            longday = longday + 60;
            div_pre--;
        }

        longday = ((div_pre - div_post) * 60) + longday;
    }
    else {
        longday = mod_post - mod_pre;
        if(longday < 0) {
            longday = longday + 60;
            div_post--;
        }

        longday = ((div_post - div_pre) * 60) + longday;
    }

    //-if(longday == 0) {
    //-    int     dummy = 0;
    //-}
    return longday;
}

int count_stockcode_num(p_str p_stockcodelist)
{
    // ڵ  
    // {A000101,A000102,A000103} - ','ڷ 
    //
    // return value:
    // (-1) :  
    // 0 >= :  

    hgassert(p_stockcodelist != nnull);
    
    if(p_stockcodelist == nnull) {
        return (-1);
    }

    //
    p_str   p_find, p_base;
    int     count;

    count = 0;
    p_base = p_stockcodelist;
    do {
        p_find = strchr(p_base, stockdelimt);
        if(p_find == nnull) {
            if(hgstrlen(p_base) > 0) {
                count++;
            }
            break;
        }

        //
        count++;

        //
        p_find++;
        if(p_find[0] == 0x00) {
            break;
        }

        //
        p_base = p_find;
    }
    while(1);

    return count;
}

long count_limitmax(long basevalue, bbool updown_flag)
{
    if(basevalue <= 0) {
        hgdbgbrk;
        return 0;   // 
    }

    float   count;
    long    maxvalue;

    count = (float)((float)basevalue * (float)0.15);

    maxvalue = (long)count;
    int     mergeval;
    int     modval = 0;
    int     modbase = 0;

    if(updown_flag == ttrue) {
        //-------------------------------------------------------------
        // Ѱ ϱ - ̶ ģ  ȣ  Ѵ.
        // ö ȣ  ٲ Ѱݸ ʰѴ.
        //-------------------------------------------------------------
        mergeval = basevalue + maxvalue;

        if(mergeval < 5000) {
            modval = mergeval % 5;
            modbase = 5;    // Ѱ Ҷ ø 
        }
        else if(mergeval < 10000) {
            modval = mergeval % 10;
            modbase = 10;    // Ѱ Ҷ ø 
        }
        else if(mergeval < 50000) {
            modval = mergeval % 50;
            modbase = 50;    // Ѱ Ҷ ø 
        }
        else if(mergeval < 100000) {
            modval = mergeval % 100;
            modbase = 100;    // Ѱ Ҷ ø 
        }
        else if(mergeval < 500000) {
            modval = mergeval % 500;
            modbase = 500;    // Ѱ Ҷ ø 
        }
        else {  // 50 ̻
            modval = mergeval % 1000;
            modbase = 1000;    // Ѱ Ҷ ø 
        }
    }
    else {
        //-------------------------------------------------------------
        // Ѱ ϱ - ̶   ȣ  Ѵ.
        // ļ Ȯϰ غ     ִµ
        // ׷ ϸ HTS  ̶ ٸ ´.
        // ׷ ذ() Ѱ Ѵ.
        //-------------------------------------------------------------
        //-mergeval = basevalue - maxvalue;
        //-------------------------------------------------------------
        mergeval = basevalue;

        if(mergeval < 5000) {
            modval = maxvalue % 5;
            modbase = 5;    // Ѱ Ҷ ø 
        }
        else if(mergeval < 10000) {
            modval = maxvalue % 10;
            modbase = 10;    // Ѱ Ҷ ø 
        }
        else if(mergeval < 50000) {
            modval = maxvalue % 50;
            modbase = 50;    // Ѱ Ҷ ø 
        }
        else if(mergeval < 100000) {
            modval = maxvalue % 100;
            modbase = 100;    // Ѱ Ҷ ø 
        }
        else if(mergeval < 500000) {
            modval = maxvalue % 500;
            modbase = 500;    // Ѱ Ҷ ø 
        }
        else {  // 50 ̻
            modval = maxvalue % 1000;
            modbase = 1000;    // Ѱ Ҷ ø 
        }
    }

    maxvalue -= modval;

    // 
    if(updown_flag == ffalse) { //  ϱ 
        maxvalue = (-maxvalue);
    }

    return maxvalue;
}

float calc_rate(long baseval, long nowval)
{
    float   retval = 0;

    if(baseval == 0) {
        hgdbgbrk;
        return retval;
    }

    retval = (float)((float)(nowval * 100) / (float)baseval);

    return retval;
}
